<?php
if (!defined('INIT')) exit;

function standard($value, $default_value, $ind=-1)
{
	if ($value == $ind)
		return $default_value;
	else
		return $value;
}

function validate_url($url)
{
	// Prüft, ob die URL mit http:// oder https:// beginnt.
	// Andere URL-Typen wie z.B. file:// werden aus Sicherheitsgründen gesperrt.
	// Eventuell sollten zusätzliche Verbote eingerichtet werden,
	// z.B. für http(s)://localhost
	if (preg_match(perl_regex(URL_PATTERN),$url))
	{
		return TRUE;
	}
	else
	{
 		return 'Die URL muss mit http:// oder https:// beginnen';
	}
}

function perl_regex($s)
{
	return '/^'.str_replace('/','\/',$s).'$/';
}

function in_statement($arr, $db)
{
	foreach ($arr as &$value)
	{
		$value = $db->quote($value);
	}
	unset($value);
	return '('.implode(',',$arr).')';
}

function rand_str($len)
{
	$str= '';
	$chars= 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
	$cl= strlen($chars);
	for ($i = 0; $i < $len; $i++)
	{
		$str.=$chars[mt_rand(0,$cl-1)];
	}
	return $str;
}

function yesno($b)
{
	return $b ? 'ja' : 'nein';
}

function nf($num)
{
	return number_format($num, 0, '', '.');
}

function hash_pw($pw)
{
	global $g_settings;
	return crypt($pw, '$2a$'.$g_settings['pwcost'].'$'.rand_str(22));
}

function logfile($tid,$type,$subtype,$err,$group,$title,$str)
{
	global $g_db;
	$dbs = $g_db->prepare('SELECT id FROM `'.DB_PRE.'logs` WHERE type=? AND subtype=? AND tid=? AND error=0');
	$dbs->execute(array($type, $subtype, $tid));
	while ($delfile = $dbs->fetchColumn())
	{
		@unlink('logs/'.$delfile.'.txt');
	}
	$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'logs` WHERE type=? AND subtype=? AND tid=? AND error=0');
	$dbs->execute(array($type, $subtype, $tid));
	$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'logs` (type, subtype, tid, time, error, title, `group`) VALUES (?,?,?,?,?,?,?)');
	$dbs->execute(array($type, $subtype, $tid, time(), $err, $title, $group));
	file_put_contents('logs/'.$g_db->lastInsertId().'.txt',$str);
}

function querystring($s)
{
	// Die in $s angegebene Variable aus dem Queystring entfernen und bei Bedarf ein & anhängen
	$q = (empty($_SERVER['QUERY_STRING'])) ? '' : $_SERVER['QUERY_STRING'];
	if ($s and $q)
	{
		$s = preg_quote($s,'/');
		$q = preg_replace(array('/&('.$s.'(\\=[^&]*)?&)+/', '/(^|&)('.$s.'(\\=[^&]*)?($|&))+/'),array('&',''),$q);
	}
	if ($q and substr($q,-1) != '&') $q.= '&';
	return $q;
}

function trim_errormsg($errstr)
{
	// Eingeklammerte Bereiche entfernen
	// Dann alles nach dem letzten Vorkommen von ': ' zurückgeben
	$depth=0;
	$out='';
	for ($i = strlen($errstr)-1; $i >= 0 ; $i--)
	{
		if ($errstr[$i] == ')')
		{
			$depth++;
			continue;
		}
		elseif ($errstr[$i] == '(')
		{
			$depth--;
			if ($depth < 0)
				break; // $errstr ist seltsam
			continue;
		}
		 
		if ($depth == 0)
		{
			if ($i>0 and substr($errstr,$i-1,2)==': ')
				break;
			else
				$out.=$errstr[$i]; 
		}
	}
	if ($depth < 0)
	{
		// $errstr ist seltsam, unverändert zurückgeben
		return $errstr;
	}
	return strrev($out);
}

