<?php
if (!defined('INIT')) exit;

$nav = new navi;
if (!isset($help) or !isset($nav->data[$help])) $help = 'index';
$t_navi=$nav->data[$help];

ob_start();
if ($help == 'index')
{
	$nav->write_toc();
}
elseif ($help == 'basics')
{ ?>
<p>Mit Rosmarin können Webseiten und Emailkonten auf ihre Funktionalität hin überwacht werden. Dazu werden über die Weboberfläche die Adresse einer Webseite oder die Zugangsdaten zu einem Emailkonto angegeben. Rosmarin wird dann in regelmäßigen Abständen überprüfen, ob die angegebenen Webseiten verfügbar sind und (wenn gewünscht) ob der Seiteninhalt noch der gleiche ist. Außerdem werden in regelmäßigen Abständen Emails an die angegebenen Emailkonten gesendet und es wird überprüft, ob diese Emails ihr Ziel erreichen.</p>
<p>Falls bei diesen regelmäßigen Prüfungen ein Problem festgestellt wird, versendet Rosmarin an die dafür eingetragenen Emailadressen eine Warnung. Zusätzlich wird ein Protokoll angelegt. Das Protokoll lässt sich über die Weboberfläche einsehen und kann bei der Fehlersuche helfen.</p>
<?php }
elseif ($help == 'u_g')
{ ?>
<?php $nav->write_h('Nutzer'); ?>
<p>In Rosmarin gibt es zwei Arten von Benutzerkonten: Standardnutzer und Administratoren. Administrator sind alle Benutzer, die Zugriff auf die Gruppe Admin haben. Folgende Aufgaben können nur von Administratoren durchgeführt werden: Nutzer verwalten, Gruppen verwalten, globale Einstellungen ändern, Fehlermeldungen zu fehlgeschlagenem Emailversand lesen.</p>
<?php $nav->write_h('Gruppen'); ?>
<p>Gruppen dienen dazu, die Tests zu verwalten und den Zugriff auf die Testeinstellungen und -ergebnisse zu regeln. Jeder Test gehört zu genau einer Gruppe. Ein Test kann nur von Nutzern betrachtet und bearbeitet werden, die eine Zugriffsberechtigung für diese Gruppe haben.</p>
<p>In der Menüleiste wird stets angezeigt, welche Gruppe gerade aktiv ist (d.h. die Tests und Einstellungen welcher Gruppe angezeigt werden). Um in eine andere Gruppe zu wechseln, klickt man in der Menüleiste auf das kleine Dreieck neben dem Namen der aktiven Gruppe und wählt eine andere Gruppe aus dem Popup-Menü.</p>
<p>Für jede Gruppe können Standardwerte angegeben werden, die das Verhalten der Tests bestimmen. Allerdings sind diese Standardwerte nicht bindend, d.h. es können für jeden einzelnen Test abweichende Werte angegeben werden. Außerdem kann für jede Gruppe eine Emailbenachrichtigung eingerichtet werden. Falls bei der <?php $nav->write_link('cron') ?> Fehler gefunden werden, wird eine Email an die angegebene(n) Emailadresse(n) gesendet.</p>
<?php $nav->write_h('Die Admin-Gruppe'); ?>
<p>Die Admin-Gruppe kann so verwendet werden wie jede andere Gruppe auch. Allerdings hat sie einige Sonderfunktionen, weshalb empfohlen wird, in dieser Gruppe keine Tests anzulegen.</p>
<p>Die Admin-Gruppe kann nicht umbenannt oder gelöscht werden. Jeder Nutzer, der Zugriff auf die Admin-Gruppe hat, ist ein Administrator und hat dadurch zusätzliche Berechtigungen (siehe Abschnitt Nutzer). Einstellungen, die für die Admin-Gruppe getroffen werden, gelten als Standardwert für alle anderen Gruppen. Für den Versand von Warnmeldungen per Email im Rahmen der <?php $nav->write_link('cron') ?> wird die Versandart verwendet, die für die Admin-Gruppe festgelegt ist.</p>
<?php }
elseif ($help == 'webtest')
{ ?>
<p>Mit einem Webtest kann die Verfügbarkeit einer Webseite unter einer bestimmten URL überwacht werden. Dabei kann bei Bedarf auch der HTTP-Statuscode und/oder der Seiteninhalt mit überwacht werden.</p>
<p>In der Übersicht werden alle Webtests der aktiven Gruppe angezeigt. Zur besseren Übersicht sind sie farbig hinterlegt: Wenn die Seite bei der letzten Prüfung den Erwartungen entsprach, wird der Test in grün angezeigt, andernfalls rot. Inaktive Tests sind unabhängig vom Testergebnis grau.</p>
<p>Die angezeigten Testergebnisse werden nicht ständig aktualisiert, sondern nur bei einer Cron-Prüfung. Wird ein aktelles Ergebnis benötigt, kann für einzelne Tests durch die Aktion ‚jetzt prüfen‘ eine zusätzliche Prüfung durchgeführt werden.</p>
<?php $nav->write_h('Webtests verwalten'); ?>
Für bereits angelegte Webtests können folgende Aktionen durchgeführt werden:
<dl>
	<dt>bearbeiten</dt>
	<dd>die Einstellungen für diesen Test können überarbeitet werden (siehe unten)</dd>
	<dt>aktivieren</dt>
	<dd>der Test wird aktiv geschaltet, d.h. er wird in Zukunft bei jeder Cron-Prüfung durchgeführt</dd>
	<dt>deaktivieren</dt>
	<dd>der Test wird inaktiv geschaltet, d.h. er wird in Zukunft bei einer Cron-Prüfung <strong>nicht</strong> durchgeführt</dd>
	<dt>Wert übernehmen</dt>
	<dd>das unter ‚Gefunden‘ angezeigte Ergebnis der letzten Prüfung wird in Zukunft als Erwartungswert verwendet</dd>
	<dt>jetzt prüfen</dt>
	<dd>der angezeigte Status der Webseite kann veraltet sein. Durch diese Aktion wird der Test erneut durchgeführt.</dd>
	<dt>löschen</dt>
	<dd>der Test wird gelöscht</dd>
</dl>
<?php $nav->write_h('Webtests anlegen und bearbeiten'); ?>
Beim Anlegen und Bearbeiten von Tests gibt es folgende Einstellungen:
<dl>
	<dt>URL</dt>
	<dd>Die URL, die überprüft werden soll. Es ist nur http:// und https:// zulässig</dd>
	<dt>Anmerkung</dt>
	<dd>Hier kann ein Name oder eine kurze Beschreibung für den Test angegeben werden. Dieses Feld kann auch leergelassen werden.</dd>
</dl>
Für die folgenden Einstellungen kann wahlweise der Standardwert der Gruppe verwendet oder ein eigener Wert eingegeben werden. Die Verwendung des Standardwertes ermöglicht es, die Parameter für die Tests zentral über die <?php $nav->write_link('sett_activegroup', 'Gruppeneinstellungen'); ?> zu verwalten.
<dl>
	<dt>Zeitlimit in Sekunden</dt>
	<dd>Das Laden der zu prüfenden Webseite wird nach der angegebenen Zeitdauer abgebrochen. Als Ergebnis wird dann ein Fehler angezeigt. Diese Einstellung funktioniert mit der <?php $nav->write_link('weblib'); ?> ‚Simple‘ nicht zuverlässig.</dd>
	<dt>Wiederholungen</dt>
	<dd>Bei der Cron-Prüfung wird ein Test so oft wiederholt, bis das Ergebnis mit dem Erwarungswert übereinstimmt. Mit dieser Einstellung wird die Maximalanzahl für Wiederholungen festgelegt. 0 deaktiviert die Wiederholungen komplett. Wenn der Test wiederholt werden muss, weil das Testergebnis nicht zum Erwartungswert passt, dann gilt er als fehlgeschlagen (er wird rot angezeigt und es wird eine Email-Nachricht verschickt), auch wenn er in der Wiederholung erfolgreich ist. Indem man einige Wiederholungen zulässt, kann man im Nachhinein feststellen, ob der Fehler nur einmalig oder über einen gewissen Zeitraum aufgetreten ist. Wenn ein Test mit der Aktion ‚jetzt prüfen‘ ausgeführt wird, hat diese Einstellung keine Bedeutung.</dd>
	<dt>Weiterleitungen</dt>
	<dd>Dieser Wert gibt an, wie oft einer HTTP-Weiterleitung (3**-Statuscode) gefolgt werden soll. Eine Einstellung für „unendlich oft folgen“ gibt es nicht, als Behelf kann eine große Zahl (z.B. 20) angegeben werden. Rosmarin erkennt nicht, wenn die Weiterleitung in eine Endlosschleife führt. Die Zahl der möglichen Wiederholungen sollte deshalb nicht zu groß gewählt werden.</dd>
	<dt>Statuscode prüfen</dt>
	<dd>Wenn diese Option aktiviert ist, dann ist der HTTP-Statuscode Teil des Erwartungswerts. Wenn die zu prüfende Webseite einen anderen Statuscode liefert, gilt der Test als fehlgeschlagen. Achtung: Wenn diese Option deaktiviert wird, dann gilt der Test unabhängig vom Statuscode als erfolgreich, also beispielsweise auch bei 404 Not Found.</dd>
	<dt>Inhalt prüfen</dt>
	<dd>Wenn diese Option aktiviert ist, dann ist der Content-Type und der komplette HTTP-Body (genauer gesagt die md5-Summe davon) Teil des Erwartungswerts. Der Test wird also fehlschlagen, sobald sich auch nur ein Zeichen im Quellcode der Webseite ändert.</dd>
	<dt>SSL-Zertifikat prüfen</dt>
	<dd>Wenn diese Option aktiviert ist, wird überprüft, ob das SSL-Zertifikat gültig ist (d.h. ob es zum Domainnamen passt, nicht abgelaufen ist, ...) und ob es von einer vertrauenswürdigen Stelle unterschrieben ist. Wenn die Webtest-Methode ‚Simple‘ benutzt wird, muss diese Option eventuell deaktiviert werden, da Subject Alternative Name (SAN) nicht unterstützt wird.</dd>
</dl>
<p><strong>Hinweis:</strong> Wenn ein Webtest gespeichert wird, so wird automatisch die Aktion ‚jetzt prüfen‘ ausgeführt.</p>
<?php }
elseif ($help == 'mailtest')
{ ?>
<p>Mit einem Emailtest kann überprüft werden, ob Emails an eine bestimmte Emailadresse auch tatsächlich ihr Ziel erreichen. Dazu wird eine Email mit einem eindeutigen Code an die angegebene Emailadresse gesendet, anschließend wird geprüft, ob die Email innerhalb einer bestimmten Zeitspanne im zugeörigen Postfach ankommt. Die Emails im Postfach werden nach jeder Überprüfung gelöscht, es sollten also keine Emailadressen angegeben werden, die auch außerhalb von Rosmarin verwendet werden.</p>
<p>In der Übersicht werden alle Mailtests der aktiven Gruppe angezeigt. Zur besseren Übersicht sind sie farbig hinterlegt: Wenn der Versand der Testmails länger dauert als erwartet wird der Test rot angezeigt, andernfalls grün. Inaktive Tests sind unabhängig vom Testergebnis grau.</p>
<p>Die Email-Postfächer werden nicht ständig überwacht, sondern nur bei einer Cron-Prüfung. Wird ein aktelles Ergebnis benötigt, kann für einzelne Tests durch die Aktion ‚jetzt prüfen‘ eine zusätzliche Prüfung durchgeführt werden.</p>
<?php $nav->write_h('Mailtests verwalten'); ?>
Für bereits angelegte Mailtests können folgende Aktionen durchgeführt werden:
<dl>
	<dt>bearbeiten</dt>
	<dd>die Einstellungen für diesen Test können überarbeitet werden (siehe unten)</dd>
	<dt>aktivieren</dt>
	<dd>der Test wird aktiv geschaltet, d.h. er wird in Zukunft bei jeder Cron-Prüfung durchgeführt</dd>
	<dt>deaktivieren</dt>
	<dd>der Test wird inaktiv geschaltet, d.h. er wird in Zukunft bei einer Cron-Prüfung <strong>nicht</strong> durchgeführt</dd>
	<dt>zurücksetzen</dt>
	<dd>die Liste mit den Emails, die noch vermisst werden, wird gelöscht. Diese Aktion sollte durchgeführt werden, wenn durch eine Störung des Mailservers einige Mails verloren gegangen sind.</dd>
	<dt>Mails senden</dt>
	<dd>normalerweise werden nur während der Cron-Prüfung Testmails versendet. Mit dieser Aktion kann eine zusätzliche Testmail gesendet werden.</dd>
	<dt>Mails abrufen</dt>
	<dd>der angezeigte Status der kann veraltet sein. Durch diese Aktion wird das Postfach erneut überprüft.</dd>
	<dt>löschen</dt>
	<dd>der Test wird gelöscht</dd>
</dl>
<?php $nav->write_h('Mailtests anlegen und bearbeiten'); ?>
Beim Anlegen und Bearbeiten von Tests gibt es folgende Einstellungen:
<dl>
	<dt>Adressen</dt>
	<dd>Eine oder mehrere Emailadressen (mit Komma getrennt), die überprüft werden sollen. Alle Emailadressen müssen zum gleichen Postfach gehören. Um mehrere Postfächer zu überwachen, müssen Sie entsprechend viele verschiedene Mailtests anlegen.</dd>
	<dt>Pfad</dt>
	<dd>Der IMAP- oder POP3-Server, auf dem sich das zu überwachende Postfach befindet. Das genaue Format ist unter <?php $nav->write_link('imap_path'); ?> beschrieben. Achtung: Die Nachrichten in diesem Postfach werden nach jeder Überprüfung gelöscht. Wenn Sie in mehreren Mailtests das gleiche Postfach (d.h. die gleiche Kombination aus Pfad und Nutzernamen) benutzen, wird dies zu vermissten Emails führen.</dd>
	<dt>Nutzername</dt>
	<dd>Der Nutzername für das Postfach. Oft ist die Emailadresse auch gleichzeitig der Nutzername</dd>
	<dt>Passwort</dt>
	<dd>Das Passwort des Postfachs</dd>
</dl>
Für die folgenden Einstellungen kann wahlweise der Standardwert der Gruppe verwendet oder ein eigener Wert eingegeben werden. Die Verwendung des Standardwertes ermöglicht es, die Parameter für die Tests zentral über die <?php $nav->write_link('sett_activegroup', 'Gruppeneinstellungen'); ?> zu verwalten.
<dl>
	<dt>Zeitlimit in Minuten</dt>
	<dd>Dieser Wert gibt an, wie lange die Zustellung einer Email dauern darf. Wird die angegebene Zeit überschritten, führt dies zu einer Warnung. Hinweis: Da zwischen den Prüfungen ein gewisser zeitlicher Abstand liegt, kann nicht genau festgestellt werden, wie lange die Zustellung einer Email gedauert hat. Wenn die Cron-Prüfung beispielsweise aller 60 Minuten stattfindet, dann wird eine Email-Zustellung, die 59 Minuten oder weniger dauert, unabhängig vom Zeitlimit keine Warnung erzeugen.</dd>
	<dt>Mailversand</dt>
	<dd>Die Testmails können entweder mit der PHP-Funktion mail() oder über einen selbst gewählten SMTP-Server versendet werden. Näheres zu SMTP-Servern findet sich unter <?php $nav->write_link('sett_smtp'); ?>. Falls in der Admin-Gruppe ein SMTP-Server als Standardversand festgelegt wurde, kann dieser ebenfalls genutzt werden. Er wird in der Liste als ‚globaler SMTP‘ angezeigt.</dd>
</dl>
<p><strong>Hinweis:</strong> Wenn ein Mailtest gespeichert wird, so wird automatisch die Aktion ‚zurücksetzen‘ ausgeführt.</p>
<?php }
elseif ($help == 'imap_path')
{ ?>
<p>
	Der Mailbox-Pfad fasst mehrere Informationen zusammen, die zum Abrufen der Emails notwendig sind: Die Serveradresse, den zu überprüfenden Ordner auf dem Server und zusätzliche Optionen für den Verbindungsaufbau.
</p>
<?php $nav->write_h('Das Format'); ?>
<p>
	Der Mailbox-Pfad wird in folgendem Format angegeben: <b>&quot;{&quot; Serveradresse [ Optionen ] &quot;}&quot; [ Ordnername ]</b>
</p>
<dl>
	<dt>Serveradresse</dt>
	<dd>Der Domainname oder die IP-Adresse des Servers. Eine Portnummer kann getrennt durch einen Doppelpunkt angegeben werden. Wenn keine Portnummer angegeben ist, wird der Standardport verwendet.</dd>
	<dt>Optionen</dt>
	<dd>Für die Verbindung zum Server können Optionen angegeben werden. Falls mehrere Optionen verwendet werden sollen, so werden diese einfach hintereinander notiert. Es folgt eine Liste der wichtigsten Optionen. Eine vollständige Liste finden sie im <a href="http://php.net/imap-open" target="_blank">PHP-Handbuch</a>
	<table class="htable">
		<tr><th>Option</th><th>Beschreibung</th></tr>
		<tr><td>/pop3</td><td>POP3 verwenden (Standard ist IMAP)</td></tr>
		<tr><td>/secure</td><td>Übertragung von Klartext-Passwörtern wird verhindert (nicht notwendig mit /ssl oder /tls)</td></tr>
		<tr><td>/ssl</td><td>SSL verwenden</td></tr>
		<tr><td>/tls</td><td>STARTTLS verwenden. Verbindung abbrechen, wenn dies nicht möglich ist</td></tr>
		<tr><td>/notls</td><td>STARTTLS nicht verwenden, auch wenn der Server es unterstützt</td></tr>
		<tr><td>/novalidate-cert</td><td>TLS/SSL-Zertifikat nicht überprüfen</td></tr>
	</table>
	</dd>
	<dt>Ordnername</dt>
	<dd>Auf IMAP-Servern gibt es mehrere Ordner. Standardmäßig wird der Ordner INBOX (der Posteingang) überprüft. Wenn ein anderer Ordner geprüft werden soll, kann dies hier angegeben werden. Falls der Ordnername Sonderzeichen enthält, muss er kodiert werden:
	<p>
	<a name="encode"></a>
	<form method="post" accept-charset="utf-8" action="help.php?help=imap_path#encode">
		<input type="text" size="20" name="mailboxname"<?php if (isset($_POST['mailboxname'])) echo ' value="'.htmlspecialchars($_POST['mailboxname']).'"'; ?>>
		<input type="submit" value="kodieren" name="submit">
		<?php if (isset($_POST['mailboxname'])) echo 'Kodierter Name: '.htmlspecialchars(imap_utf7_encode($_POST['mailboxname'])); ?>
	</form>
	</p>
	Das POP3-Protokoll unterstützt keine Ordner. Falls POP3 verwendet wird, entfällt die Angabe des Ordnernamens.
	</dd>
</dl>
<?php $nav->write_h('Beispiele'); ?>
<table>
	<tr><td>{example.com}</td><td>Mails per IMAP von example.com abrufen. Es wird der IMAP-Standardport 143 und der Standardordner INBOX verwendet.</td></tr>
	<tr><td>{example.com:995/pop3/ssl}</td><td>Mails per POP3 von example.com abrufen. Die Verbindung wird SSL-verschlüsselt über den Port 995 hergestellt.</td></tr>
	<tr><td>{example.com}Ablage</td><td>Mails per IMAP von example.com abrufen. Es wird der Ordner ‚Ablage‘ verwendet.</td></tr>
</table>
<?php }
elseif ($help == 'cron')
{ ?>
<p>
Bei der Cron-Prüfung werden die aktiven Tests aus allen Gruppen ausgeführt. Dies geschieht durch den Aufruf von cron.php. Nach der Installation von Rosmarin muss sichergestellt werden, dass dieser Ausruf regelmäßig erfolgt. Bei einige Webspace-Anbietern sind solche Cronjobs inklusive. Wenn der eigene Webspace diese Funktionalität nicht bietet, kann man auf kostenlose Angebote im Web zurückgreifen (z.B. cronjob.de).</p>
<p>Für den Aufruf von cron.php ist kein Login notwendig. Damit ein Angreifer den Server nicht überlasten kann, indem er cron.php in kurzen Abständen mehrmals aufruft, lässt sich ein zeitlicher Mindestabstand zwischen zwei Cron-Prüfungen festlegen. Wenn cron.php aufgerufen wird und die festgelegte Zeit seit der letzten Prüfung noch nicht verstrichen ist, beendet sich das Skript einfach, ohne eine Prüfung durchzuführen.</p>
<p>Weiterhin lässt sich festlegen, wie viel Zeit maximal zwischen zwei Prüfungen vergangen sein darf. Wird diese Zeit überschritten, erhalten die Administratoren bei der nächsten Prüfung eine Warnung. So kann festgestellt werden, wenn der Aufruf von cron.php nicht regelmäßig erfolgt. Wenn jedoch gar keine Aufrufe mehr stattfinden, wird prinzipbedingt keine Fehlermeldung erzeugt.</p>
<p>Wird während der Cron-Prüfung bei einem Test ein Fehler festgestellt, so wird eine Nachricht an alle Emailadressen versendet, die hierfür in den Einstellungen der entsprechenden Testgruppe festgelegt sind. Für den Versand der Warnungen wird die Versandmethode verwendet, die für die Admingruppe als Standard festgelegt ist. Falls der Versand an einige Empfänger fehlschlägt, wird eine weitere Email an die erreichbaren Emailadressen gesendet, die auf das Problem hinweist. Schlägt der Versand jedoch für alle Empfänger fehl, dann werden die Administratoren per Email über das Problem benachrichtigt. Wenn auch das nicht möglich ist, wird die Fehlermeldung auf dem Server gespeichert. Beim nächsten Login werden die Administratoren durch ein blinkendes Symbol in der Menüleiste auf die neuen Fehlermeldungen aufmerksam gemacht.<br><strong>Achtung:</strong> erfolgreicher Versand bedeutet, dass Sendmail bzw. der angegebene SMTP-Server die Email akzeptiert hat. Dies ist keine Garantie dafür, dass die Email auch tatsächlich zugestellt werden kann. Achten sie darauf, dass die angegebene Absender-Emailadresse gültig ist, denn diese Adresse wird über Probleme bei der Zustellung informiert.</p>
<?php }
elseif ($help == 'sett_index')
{
	$nav->write_toc($help);
}
elseif ($help == 'sett_user')
{ ?>
<p>Unter ‚Einstellungen: Nutzer verwalten‘ können Benutzer angelegt, umbenannt und gelöscht werden. Außerdem können Benutzerpasswörter geändert werden und es kann festgelegt werden, auf welche Gruppen ein Benutzer Zugriff hat. Diese Einstellungen können nur von Administratoren geändert werden.</p>
<p>Ein Administrator kann auch sein eigenes Nutzerkonto bearbeiten, allerdings kann er es nicht löschen und er kann sich nicht die Berechtigung für die Admin-Gruppe entziehen.</p>
<p>Falls ein Benutzer in letzter Zeit sein Passwort falsch eingegeben hat, kann der Zählerstand zurückgesetzt werden, indem das Häckchen bei ‚Login-Sperre entfernen‘ gesetzt und dann gespeichert wird. Dies ist auch möglich, wenn der Benutzer sein Passwort nicht so oft falsch eingegeben hat, wie es zum Aktivieren der Sperre nötig ist. Weiteres zur Login-Sperre findet sich unter <?php $nav->write_link('sett_global'); ?></p>
<?php }
elseif ($help == 'sett_group')
{ ?>
<p>Unter ‚Einstellungen: Gruppen verwalten‘ können Gruppen angelegt, umbenannt und gelöscht werden. Außerdem kann festgelegt werden, welche Benutzer Zugriff auf eine Gruppe haben. Diese Einstellungen können nur von Administratoren geändert werden.</p>
<p>Die Admin-Gruppe kann nicht umbenannt oder gelöscht werden. Außerdem kann sich ein Administrator nicht selbst den Zugriff auf die Admin-Gruppe verweigern.</p>
<p>Um die Einstellungen für eine Gruppe zu ändern, wechseln sie in diese Gruppe und verwenden sie <?php $nav->write_link('sett_activegroup'); ?>.</p>
<?php }
elseif ($help == 'sett_global')
{ ?>
Die Globalen Einstellungen sind nur für Administratoren verfügbar. Hier können grundlegende Einstellungen zu Rosmarin getroffen werden.
<dl>
	<dt>Login-Dauer</dt>
	<dd>Wenn ein Nutzer länger als für die hier angegebene Zeit keine Aktivitäten in Rosmarin ausführt, wird er automatisch ausgeloggt.</dd>
	<dt>Login-Versuche</dt>
	<dd>Wird mehrmals hintereinander versucht, sich mit einem falschen Passwort in ein bestimmtes Nutzerkonto einzuloggen, dann wird dieser Nutzername für einige Zeit gesperrt. Dies gilt auch für Nutzernamen, zu denen es gar kein Nutzerkonto gibt. Mit diesem Wert wird festgelegt, nach wie vielen Fehlversuchen ein Nutezrname gesperrt wird.</dd>
	<dt>Login-Sperrdauer</dt>
	<dd>Mit diesem Wert wird festgelegt, wie lange es dauert, bis für einen gesperrten Nutzer wieder ein Loginversuch möglich ist. D.h. nach dieser Zeit ist ein einziger weiterer Versuch möglich. Wenn also beispielsweise 5 Login-Versuche mit einer Sperrdauer von 10 Minuten festgelegt sind, dann dauert es nach einer Sperre 50 Minuten, bis der Nutzer wieder 5 Login-Versuche hat (vorausgesetzt, der Nutzer hat innerhalb dieser 50 Minuten nicht schon weitere Versuche unternommen). Der Zähler für fehlgeschlagene Loginversuche für einen Nutzer kann von einem Administrator auf 0 zurückgesetzt werden, indem in der <?php $nav->write_link('sett_user','Nutzerverwaltung'); ?> für diesen Nutzer das Häckchen bei ‚Login-Sperre entfernen‘ gesetzt wird.</dd>
	<dt>Pause zwischen zwei Prüfungen</dt>
	<dd>Wenn das Script cron.php aufgerufen wird und seit der letzten <?php $nav->write_link('cron', 'Cron-Prüfung'); ?> weniger als die hier angegebene Zeit vergangen ist, dann führt das Script keine erneute Cron-Prüfung aus, sondern beendet sich einfach</dd>
	<dt>Cronjob-Alarm</dt>
	<dd>Wenn das Script cron.php aufgerufen wird und seit der letzten <?php $nav->write_link('cron', 'Cron-Prüfung'); ?> mehr als die hier angegebene Zeit vergangen ist, dann werden die Administratoren darüber per Email benachrichtigt. Die hier angegebene Zeit sollte also länger sein als der übliche Abstand zwischen zwei Aufrufen von cron.php. Geben Sie 0 ein, wenn keine Warnungen gewünscht sind.</dd>
	<dt>Datumsformat</dt>
	<dd>Sämtliche Uhrzeit- und Datumsangaben werden mit der PHP-Funktion date() entsprechend des hier angegebenen Formats dargestellt. Näheres dazu finden Sie im <a href="http://php.net/date" target="_blank">PHP-Handbuch</a>.</dd>
	<dt>Passwort-Kostenfaktor</dt>
	<dd>Gibt an, wie stark die Passwörter für das Rosmarin-Login verschlüsselt werden. Siehe <?php $nav->write_link('pwcost'); ?>.</dd>
	<dt>Webtest-Methode</dt>
	<dd>Es gibt verschiedene Methoden, mit denen Rosmarin eine Webseite zur Überprüfung abrufen kann. Nicht alle Methoden funktionieren auf jedem Webspace. Siehe <?php $nav->write_link('weblib'); ?>.</dd>
	<dt>PHP-Mail-Absender</dt>
	<dd>Diese Adresse wird als Absender für Emailtests verwendet, wenn als Email-Versandmethode ‚PHP-mail()‘ eingestellt ist. Falls ‚PHP-mail()’ die Standard-Versandmethode der Admin-Gruppe ist, dann werden auch alle Warn-Emails mit diesem Absender verschickt.</dd>
	<dt>URL</dt>
	<dd>Die Warnmails, die bei der Cronprüfung versendet werden, enthalten diese URL. Dadurch wird es für den Empfänger der Email leichter, sich in Rosmarin einzuloggen. Geben Sie die komplette URL an (z.B. http://example.com/rosmarin/)</dd>
</dl>
<?php }
elseif ($help == 'weblib')
{ ?>
<p>Es gibt verschiedene Möglichkeiten, eine Webseite zu überprüfen:</p>
<dl>
	<dt>Curl-Multi</dt>
	<dd>Zum Abrufen der Webseiten wird die Curl-Erweiterung genutzt. Die Webseiten werden dabei gleichzeitig abgerufen. Diese Methode ist die schnellste, benötigt aber PHP 5.2 oder höher. Bei einer langsamen Internetverbindung kann diese Methode zu Problemen führen, da eventuell die Zeitlimits überschritten werden.</dd>
	<dt>Curl-Easy</dt>
	<dd>Zum Abrufen der Webseiten wird die Curl-Erweiterung genutzt. Die Webseiten werden dabei nacheinander abgerufen.</dd>
	<dt>Simple</dt>
	<dd>Zum Abrufen der Webseiten wird der HTTP-Wrapper verwendet. Die Webseiten werden dabei nacheinander abgerufen. Zeitlimits funktionieren mit dieser Methode nicht zuverlässig. Subject Alternative Name (SAN) in SSL-Zertifikaten wird nicht unterstützt. Diese Methode funktioniert nur, wenn allow_url_fopen aktiviert ist.</dd>
	<dt>None</dt>
	<dd>Diese Methode ruft die Webseite gar nicht ab, sondern meldet immer einen Fehler</dd>
</dl>
<div class="box">
<?php $nav->write_h('Systemtest'); ?>
<table>
	<tr><td>PHP-Version</td><td><?php echo PHP_VERSION; ?></td></tr>
	<tr><td>Curl-Erweiterung verfügbar</td><td><?php echo extension_loaded('curl') ? 'ja' : 'nein'; ?></td></tr>
	<tr><td>allow_url_fopen aktiv</td><td><?php echo ini_get('allow_url_fopen') ? 'ja' : 'nein'; ?></td></tr>
</table>
Verfügbare Methoden:
<?php
	$a = array();
	if (extension_loaded('curl'))
	{
		if (strnatcmp(PHP_VERSION, '5.2') >= 0)
			$a[] = 'Curl-Multi';
		$a[] = 'Curl-Easy';
	}
	if (ini_get('allow_url_fopen'))
	{
		$a[] = 'Simple';
	}
	$a[] = 'None';
	echo implode(', ',$a);
?><br/>
Empfohlene Methode:
<?php
	echo $a[0];
?>
</div>
<?php }
elseif ($help == 'pwcost')
{ ?>
<p>Die Nutzerpasswörter werden in der Datenbank verschlüsselt abgespeichert. Dadurch soll verhindert werden, dass die Passwöter aus der Datenbank ausgelesen werden. Dies ist besonders wichtig, wenn ein Nutzer für mehrere Webseiten das gleiche Passwort verwendet.</p>
<p>Mit dem Kostenfaktor läst sich festlegen, wie aufwändig die Passwörter verschlüsselt werden. Je höher der Kostenfaktor, desto schwerer lässt sich die Verschlüsselung knacken. Allerdings wird dadurch auch die Dauer des Login-Vorgangs erhöht.</p>
<p>Der Kostenfaktor gilt nur das Passwort, mit dem sich ein Nutzer in Rosmarin einloggt. Passwörter für Emailtests werden aus technischen Gründen unverschlüsselt gespeichert.</p>
<?php if (!isset($_GET['calc'])) {
	$nav->write_link($help, 'Logindauer für verschiedene Kostenfaktoren berechnen', 'calc');
	echo ' (Dies dauert etwa 10 Sekunden)';
} else { ?>
	<table class="ltable">
		<tr><th>Faktor</th><th>Dauer in Sekunden</th></tr>
<?php
for ($i = 4; $i <= 31; $i++)
{
	$start = microtime(true);
	crypt('CKTVbBz6LlkEsjFDS6LVfE', '$2a$'.sprintf('%02u',$i).'$NCxdbHhlJLVx2w1TI4D46S');
	$end = microtime(true);
	$duration = $end - $start;
	echo '<tr><td>'.$i.'</td><td>'.sprintf('%.3F',$duration).'</td></tr>'."\n";
	if ($duration > 3)
		break;
}
?>
			</table>
		<?php } ?>
<?php }
elseif ($help == 'sett_activegroup')
{ ?>
<p>Unter ‚Einstellungen: Gruppeneinstellungen‘ können die Einstellungen für die gerade aktive Gruppe verändert werden. Die Gruppeneinstellungen sind in drei Bereiche gegliedert:
</p>
<dl>
	<dt>Web-Tests</dt>
	<dd>Hier können Standardwerte für Webtests festgelegt werden. Indem diese Werte verändert werden, kann das Verhalten aller Webtests dieser Gruppe geändert werden (dies gilt natürlich nur für Tests, die zur Verwendung von Standardwerten konfiguriert sind). Die einzelnen Einstellungen sind unter <?php $nav->write_link('webtest'); ?> erklärt.</dd>
	<dt>Mailests</dt>
	<dd>Hier können Standardwerte für Mailtests festgelegt werden. Indem diese Werte verändert werden, kann das Verhalten aller Mailtests dieser Gruppe geändert werden (dies gilt natürlich nur für Tests, die zur Verwendung von Standardwerten konfiguriert sind). Die einzelnen Einstellungen sind unter <?php $nav->write_link('mailtest'); ?> erklärt.</dd>
	<dt>Warnung per Mail</dt>
	<dd>Hier kann festgelegt werden, wer eine Warnung erhält, wenn bei während <?php $nav->write_link('cron'); ?> bei einem Test aus dieser Gruppe ein Fehler festgestellt wird. Im Feld ‚Warnungen an‘ können Emailadressen mit Komma getrennt angegeben werden. Mit ‚Abstand‘ wird festgelegt, wieviel Zeit mindestens vergehen muss, bis eine bereits gesendete Warnung noch einmal versendet wird (dies wird nur geschehen, wenn der Fehler bis dahin noch nicht behoben wurde)</dd>
</dl>
<?php }
elseif ($help == 'sett_smtp')
{ ?>
<p>
	Standardmäßig versendet Rosmarin alle Emails über die PHP-Funktion mail(). Dies gilt sowohl für Testmails im Rahmen der Mailtests als auch für Warnmeldungen, die bei Fehlern während der <?php $nav->write_link('cron'); ?> versendet werden. Emails können aber auch über beliebige SMTP-Server versendet werden. Dazu müssen zunächst unter ‚Einstellungen: SMTP‘ die Daten des SMTP-Servers eingegeben werden. Danach kann dieser SMTP-Server in den <?php $nav->write_link('sett_activegroup', 'Gruppeneinstellungen'); ?> oder in den Einstellungen eines Mailtests als Versandmethode ausgewählt werden.
</p>
<p>
	Hinweis: Die SMTP-Server werden für jede Gruppe getrennt verwaltet. Wenn Sie einen SMTP-Server in mehreren Gruppen verwenden wollen, müssen Sie ihn in jeder dieser Gruppen anlegen. Davon gibt es nur eine Ausnahme: Wird ein SMTP-Server in der Admin-Gruppe als Versandmethode festgelegt, ist dies die Standard-Versandmethode für alle anderen Gruppen und kann somit auch in allen Gruppen verwendet werden.
</p>
<p>Für SMTP-Server gibt es folgende Einstellungen:</p>
<dl>
	<dt>Bezeichnung</dt>
	<dd>Dieser Name dient dazu, die SMTP-Server innerhalb von Rosmarin voneinander zu unterscheiden. Sie können die Bezeichnung frei wählen</dd>
	<dt>Adresse</dt>
	<dd>Die Domain oder die IP, unter der der Server zu erreichen ist</dd>
	<dt>Port</dt>
	<dd>Der Port, auf dem der Server zu erreichen ist. Meist ist dies Port 587 oder Port 25 bzw. für SSL Port 465</dd>
	<dt>Verschlüsselung</dt>
	<dd>Legt fest, welche Verbindungsverschlüsselung verwendet wird<br>
	<b>keine:</b> die Verbindung bleibt unverschlüsselt<br>
	<b>STARTTLS:</b> Die Verbindung wird nach dem Verbindungsaufbau mit Hilfe des STARTTLS-Befehls verschlüsselt. Wenn der Server kein STARTTLS unterstützt, wird die Verbindung abgebrochen<br>
	<b>STARTTLS wenn möglich:</b> Die Verbindung wird nach dem Verbindungsaufbau mit Hilfe des STARTTLS-Befehls verschlüsselt. Wenn der Server kein STARTTLS unterstützt, bleibt die Verbindung unverschlüsselt. Falls der Server jedoch STARTTLS unterstützt, verhält sich diese Methode genau wie die Methode ‚STARTTLS‘. Dies gilt insbesondere in Bezug auf ungültige Zertifikate<br>
	<b>SSL:</b> Die Verbindung ist von Anfang an verschlüsselt. Dies erfordert in der Regel einen anderen Port (siehe oben)</dd>
	<dt>Authentifizierung</dt>
	<dd>Legt fest, mit welchem Verfahren Benutzernamen und Passwort übertragen werden<br>
	<b>keine:</b> Benutzernamen und Passwort werden nicht übertragen. Dies funktioniert nur, wenn der SMTP-Server anonyme Mail-Einlieferung erlaubt<br>
	<b>unverschlüsselt:</b> Benutzername und Passwort werden übertragen. Achtung: Falls die Verbindung nicht verschlüsselt ist, werden Benutzername und Passwort im Klartext übertragen</dd>
	<dt>Zertifikat prüfen</dt>
	<dd>Wenn diese Option aktiviert ist, dann wird die Verbindung abgebrochen, falls das Server-Zertifikat nicht zur Serveradresse passt oder falls das Zertifikat nicht von einer vertrauenswürdigen Stelle unterschrieben ist.<br>
	Für unverschlüsselte Verbindungen hat diese Option keine Bedeutung<br>
	Wenn diese Option aktiviert ist kann es zu Meldungen über ungültige Zertifikate kommen, obwohl das Serverzertifikat gültig ist. Dies liegt daran, dass PHP (und somit auch Rosmarin) keine Unterstützung für Subject Alternative Name (SAN) hat. In einem solchen Fall muss diese Option deaktiviert werden</dd>
	<dt>Nutzername</dt>
	<dd>Der Benutzername zur Anmeldung am SMTP-Server. Falls bei Authentifizierung ‚keine‘ gewählt ist, hat diese Einstellung keine Bedeutung</dd>
	<dt>Passwort</dt>
	<dd>Das Passwort zur Anmeldung am SMTP-Server. Falls bei Authentifizierung ‚keine‘ gewählt ist, hat diese Einstellung keine Bedeutung</dd>
	<dt>Absender</dt>
	<dd>Die Emailadresse, die als Absender verwendet wird. Falls Emails nicht zustellbar sind, wird eine Warnung an diese Adresse gesendet.</dd>
	<dt>Anmerkung</dt>
	<dd>Hier kann eine kurze Beschreibung für den SMTP-Server angegeben werden. Dieses Feld kann auch leergelassen werden.</dd>
</dl>
<?php }
elseif ($help == 'sett_info')
{ ?>
	Unter Server-Info finden sich einige Angaben zur Server-Konfiguration:
	<dl>
		<dt>Rosmarin-Version:</dt>
		<dd>Die Version dieser Rosmarin-Installation.</dd>
		<dt>PHP-Version:</dt>
		<dd>Die Version der PHP-Umgebung, in der Rosmarin ausgeführt wird.</dd>
		<dt>Webtest-Methode:</dt>
		<dd>Die Methode, mit der Webseiten bei der Überprüfung abgerufen werden. Diese Einstellung kann von Administratoren in den <?php $nav->write_link('sett_global','globalen Einstellungen'); ?> geändert werden. Unter <?php $nav->write_link('weblib'); ?> werden die verschiedenen Methoden beschrieben.</dd>
		<dt>letzte Prüfung:</dt>
		<dd>Der Zeitpunkt, an dem die Cron-Überprüfung zum letzten Mal durchgeführt wurde. Einzelheiten finden sich unter <?php $nav->write_link('cron'); ?>.</dd>
	</dl>
<?php }
elseif ($help == 'sett_private')
{ ?>
	In den privaten Einstellungen kann ein Nutzer Einstellungen vornehmen, die nur sein Benutzerkonto betreffen. Zur Zeit lässt sich hier nur das eigene Passwort ändern.
<?php }
elseif ($help == 'logs')
{ ?>
<p>
	Bei der Durchführung der Tests erzeugt Rosmarin Logdateien, mit deren Hilfe die aufgetretenen Fehler im Nachhinein analysiert werden können:
	<ul>
		<li>Für HTTP-Verbindungen werden die Antworten des Servers aufgezeichnet. Im Falle von Weiterleitungen werden alle Header, aber nur der letzte Body aufgezeichnet.</li>
		<li>Für SMTP-Verbindungen wird der komplette Datenverkehr aufgezeichnet</li>
		<li>Für POP3- und IMAP-Verbindungen werden Warn- und Fehlermeldungen aufgezeichnet</li>
		<li>Für die mail()-Funktion gibt es keine Logdateien</li>
	</ul>
	</p>
	<p>
	Für Webtests wird eine Logdatei pro Testlauf angelegt, für Mailtests wird eine Logdatei für das Versenden und eine Logdatei für das Abrufen angelegt (wenn ein Mailtest die mail()-Funktion für den Versand nutzt, dann gibt es nur eine Logdatei).</p>
	<p>Es wird jeweils die letzte Logdatei für jeden Test gespeichert, außerdem die Logdateien von allen Testdurchführungen, bei denen Fehler aufgetreten sind (Webtests, die nicht dem Erwartungswert entsprachen und Mailtests, bei denen das Senden oder Empfangen fehlgeschlagen ist).</p>
	<p>In der Logübersicht werden die Logdateien chronologisch angezeigt. Falls ein Fehler aufgetreten ist, ist der Eintrag in der Liste rot hinterlegt. Die Logdateien können nach Typ (alle, Webtests, Mailtests) gefiltert werden. Durch einen Klick auf das Filter-Symbol kann die Auflistung auch auf einen einzigen Test beschränkt werden.</p>
	<p>Um eine größere Anzahl von Logdateien zu löschen, gibt es die Funktion ‚und alle älteren‘. Wird diese Funktion beim Löschen aktiviert, so werden die neueste der ausgewählten Logdateien sowie alle älteren gelöscht. Falls die Logdateien auf mehreren Seiten angezeigt werden, so werden auch die Logdateien auf den folgenden Seiten gelöscht. Ein aktiver Filter wirkt sich auf die Funktion ‚und alle älteren‘ aus. Es lassen sich also beispielsweise alle Logdateien zu Mailtests löschen, indem man sich nur die Mailtests anzeigen lässt, dann ein Häckchen bei der ersten Logdatei sowie bei ‚und alle älteren‘ setzt und anschließend auf ‚Löschen‘ klickt.</p>
<?php }
elseif ($help == 'faterror')
{ ?>
Falls während der <?php $nav->write_link('cron') ?> Fehler auftreten, wird Rosmarin mehrere Versuche unternehmen, eine Fehlermeldung per Email zu versenden. Falls alle diese Versuche scheitern, wird die Fehlermeldung in eine Textdatei gespeichert. Administratoren werden durch einen zusätzlichen blinkenden Eintrag in der Menüleiste auf diesen Umstand hingewiesen. Die Fehlermeldungen können dann von Administratoren gelesen und gelöscht werden.
<?php }
elseif ($help == 'license')
{ ?>
<p><a href="http://www.ungelesen.net/rosmarin/">Rosmarin</a> ist unter der <a href="http://www.gnu.org/licenses/agpl-3.0.en.html" target="_blank">GNU AGPL Version 3</a> oder später lizensiert.</p>
<p>Rosmarin verwendet die Javascript-Bibliothek <a href="http://jquery.org" target="_blank">jQuery</a>. jQuery steht unter der MIT-Lizenz (<a href="http://jquery.org/license/" target="_blank">http://jquery.org/license/</a>).</p>
<p>Die in Rosmarin enthaltenen Grafiken sind unter der <a target="_blank" href="http://creativecommons.org/licenses/by/3.0/de/">Creative-Commons-Lizenz vom Typ Namensnennung 3.0 Deutschland</a> lizenziert. Sie basieren auf:</p>
<ul>
	<li><a href="http://www.famfamfam.com/lab/icons/silk/" target="_blank">Silk icon set 1.3</a> © Mark James, <a href="http://creativecommons.org/licenses/by/2.5/" target="_blank">Creative Commons Attribution 2.5 license</a></li>
	<li><a href="http://p.yusukekamiyamane.com/" target="_blank">Diagona Icons</a> © 2007 Yusuke Kamiyamane, <a href="http://creativecommons.org/licenses/by/3.0/" target="_blank">Creative Commons Attribution 3.0 license</a></li>
	<li><a href="http://commons.wikimedia.org/wiki/File:Rosmarinus_officinalis_Blanco1.94.png" target="_blank">Flora de Filipinas: Rosmarinus officinalis</a>, gemeinfrei</li>
</ul>
<?php }

$t_content=ob_get_clean();


class navi {

	private $struct = array(
		'index' => array(
			'basics',
			'u_g',
			'webtest',
			'mailtest' => array(
				'imap_path',
				),
			'cron',
			'sett_index' => array(
				'sett_user',
				'sett_group',
				'sett_global' => array(
					'weblib',
					'pwcost',
					),
				'sett_activegroup',
				'sett_smtp',
				'sett_info',
				'sett_private',
				),
			'logs',
			'faterror',
			'license',
			),
		);

	private $titles = array(
		'index' => 'Übersicht',
		'basics' => 'Grundlagen',
		'u_g' => 'Nutzer und Gruppen',
		'webtest' => 'Webtests',
		'mailtest' => 'Email-Tests',
		'imap_path' => 'Mailbox-Pfad',
		'cron' => 'Cron-Prüfung',
		'sett_index' => 'Einstellungen',
		'sett_user' => 'Einstellungen: Nutzer',
		'sett_group' => 'Einstellungen: Gruppen',
		'sett_global' => 'Globale Einstellungen',
		'weblib' => 'Einstellungen: Webtest-Methode',
		'pwcost' => 'Einstellungen: Passwort-Kostenfaktor',
		'sett_activegroup' => 'Einstellungen: aktive Gruppe',
		'sett_smtp' => 'Einstellungen: SMTP',
		'sett_info' => 'Einstellungen: Server-Info',
		'sett_private' => 'private Einstellungen',
		'logs' => 'Logs',
		'faterror' => 'Fehler',
		'license' => 'Lizenzen',
		);
	
	public $data = array();

	private function firstitem($a)
	{
		$keys = array_keys($a);
		return (is_array($a[$keys[0]])) ? $keys[0] : $a[$keys[0]];
	}

	private function lastitem($a)
	{
		$keys = array_keys($a);
		$last = count($keys)-1;
		return (is_array($a[$keys[$last]])) ? $keys[$last] : $a[$keys[$last]];
	}

	private function scan_struct($from, $p=false)
	{
		$prev = false;
		foreach ($from as $k=>$v)
		{
			if (is_array($v))
			{
				$this->scan_struct($v, $k);
				$this->data[$k] = array(
					'parent' => $p,
					'prevsib' => $prev,
					'nextsib' => false,
					'prev' => $prev ? $prev : $p,
					'next' => $this->firstitem($v),
					'firstchild' => $this->firstitem($v),
					'lastchild' => $this->lastitem($v),
					'title' => $this->titles[$k],
					);
				if ($prev)
				{
					$this->data[$prev]['nextsib']=$k;
					if ($this->data[$prev]['next']) $this->data[$this->data[$prev]['lastchild']]['next']=$k;
					else $this->data[$prev]['next']=$k;
				}
				$prev=$k;
				}
			else
			{
				$this->data[$v] = array(
					'parent' => $p,
					'prevsib' => $prev,
					'nextsib' => false,
					'prev' => $prev ? $prev : $p,
					'next' => false,
					'firstchild' => false,
					'lastchild' => false,
					'title' => $this->titles[$v],
					);
				if ($prev)
				{
					$this->data[$prev]['nextsib']=$v;
					if ($this->data[$prev]['next']) $this->data[$this->data[$prev]['lastchild']]['next']=$v;
					else $this->data[$prev]['next']=$v;
				}
				$prev=$v;
			}
		}
	}
	
	function __construct()
	{
		$this->scan_struct($this->struct);
	}
	
	function write_link($topic, $title=false, $var= false, $content=false)
	{
		if (!$title) $title = htmlspecialchars($this->data[$topic]['title']);
		echo '<a href="help.php?help='.htmlspecialchars($topic).($var ? '&'.urlencode($var).($content ? '='.urlencode($content) : '') : '').'">'.$title.'</a>';
	}
	
	function write_toc($item=false)
	{
		if (!$item) $item = 'index';
		$item = $this->data[$item]['firstchild'];
		
		echo '<div class="toc">'.LF;
		do {
			$this->write_link($item);
			echo '<br>'.LF;
			if ($this->data[$item]['firstchild'])
			{
				$this->write_toc($item);
			}
			
		} while ($item = $this->data[$item]['nextsib']);
		echo '</div>'.LF;
	}
	
	function write_h($s)
	{
		echo '<h2>'.$s.'</h2>'.LF;
	}
	
	function write_name($item=false)
	{
		if (!$item) $item = 'index';
		echo htmlspecialchars($this->data[$topic]['title']);
	}
}
