<?php

class imap_mail {
	private $log = '';
	private $lasterror = '';

	function check ($path, $user, $pass, $hashes)
	{
		if ($conn = @imap_open($path, $user, $pass))
		{
			$this->imap_log();
			$this->log('Verbindung hergestellt');
			
			$msgnum=imap_num_msg($conn);
			$this->imap_log();
			$this->log($msgnum.' neue Nachricht(en)');
			
			if ($msgnum)
			{
				$this->log('');
				$this->log('Suche nach Hashes:');
				$this->log($hashes);
				$this->log('');
			}
			
			$received = array();
			for ($i=1;$i<=$msgnum;$i++)
			{
				$body = imap_body($conn,$i);
				$this->imap_log();
				foreach ($hashes as $hash)
				{
					if (strpos($body,$hash)!==false)
					{
						$received[]=$hash;
					}
				}
			}
			
			if ($msgnum)
			{
				if (!empty($received))
				{
					$this->log('Gefundene Hashes:');
					$this->log($received);
					$this->log('');
				}
				else
				{
					$this->log('Keine Hashes gefunden');
				}
				
				$this->log('Lösche '.$msgnum.' Nachricht(en)');
				imap_delete($conn,'1:'.$msgnum);
				$this->imap_log();
			}
			
			imap_close($conn,CL_EXPUNGE);
			$this->imap_log();
			$this->log('Verbindung getrennt');
			
			return $received;
		}
		
		$this->imap_log();
		$this->log('Konnte keine Verbindung herstellen',true);
		
		return FALSE;
	}
	
	private function imap_log()
	{
		if ($x=imap_errors()) $this->log($x);
		if ($x=imap_alerts()) $this->log($x);
	}
	
	private function log($str, $setlasterror=false)
	{
		if (is_array($str))
		{
			foreach ($str as $s)
			{
				$this->log .= $s."\r\n";
			}
		}
		else
		{
			$this->log .= $str."\r\n";
		}
		if ($setlasterror)
			$this->lasterror = $str;
	}
	
	function getlog()
	{
		$temp = $this->log;
		$this->log = '';
		return $temp;
	}
	
	function geterror()
	{
		return $this->lasterror;
	}
}

