<?php
define('INIT','');
require_once('config.php');

define('VERSION', '0.9.2');

define('MAIL_PATTERN', ' *[^,@ ]+@[^,@ ]+( *, *[^,@ ]+@[^,@ ]+)* *');
define('SINGLE_MAIL_PATTERN', ' *[^,@ ]+@[^,@ ]+ *');
define('IMAP_PATTERN', '{.+}.*');
define('URL_PATTERN', 'https?://.*');
define('FERR_PATTERN', '/^(([0-9]+)(-([0-9]*))?).txt$/');
define('LF',"\n");

if (DEBUG)
{
	function my_error_handler($errno)
	{
		if (error_reporting() & $errno)
		// Error-Reporting-Direktive beachten
		{
			ob_start();
			print_r(debug_backtrace());
			echo nl2br(str_replace(' ','&nbsp;',htmlentities(ob_get_clean())));
		}
		return FALSE;
	}
	set_error_handler('my_error_handler');
}

function db_connect_error($exception)
{
	$t_error = 'Keine Verbindung zur Datenbank';
	require('error.template.php');
	if (DEBUG)
	{
		ob_start();
		print_r($e);
		echo nl2br(str_replace(' ','&nbsp;',htmlentities(ob_get_clean())));
	}
	exit;
}

require_once('functions.php');
// Datenbank-Verbindung
require_once('db.php');

$t_warnings = array();
$t_infos = array();

try
{
	// User-Login
	require_once('session.php');
	
	if (isset($_GET['setgroup']))
	{
		$_POST['setgroup'] = $_GET['setgroup'];
	}
	if (isset($_POST['setgroup']))
	{
		// Nutzer will aktive Gruppe wechseln
		$dbs = $g_db->prepare('SELECT groups.name FROM `'.DB_PRE.'usergroup` AS usergroup JOIN `'.DB_PRE.'groups` AS groups ON usergroup.gid = groups.id WHERE usergroup.uid=? AND usergroup.gid=?');
		$dbs->execute(array($g_userid,$_POST['setgroup']));
		if ($new_group_name = $dbs->fetchColumn())
		{
			// Nutzer ist zum Gruppenwechsel berechtigt
			$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'session` SET active_group=? WHERE sessid=?');
			$dbs->execute(array($_POST['setgroup'], $g_sessionid));
			$g_active_group = $_POST['setgroup'];
			$g_active_group_name = $new_group_name;
		}
		else
		{
			$t_warnings[] = 'Keine Berechtigung für diese Gruppe';
		}
	}
	
	$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'usergroup` WHERE uid=? AND gid=0');
	$dbs->execute(array($g_userid));
	$g_is_admin = $dbs->fetchColumn();
	
	if (isset($_GET['settings']))
	{
		$g_mode = 'settings';
		require('settings.php');
	}
	elseif (isset($_GET['logs']))
	{
		$g_mode = 'logs';
		require('logs.php');
	}
	else
	{
		$g_mode = 'testlist';
		require('tests.php');
	}
	
	//Liste aller Gruppen des Nutzers
	//Dies wird erst nach settings.php ausgeführt, da settings.php
	//die Gruppen eines Nutzers ändern kann
	$dbs = $g_db->prepare('SELECT groups.id, groups.name FROM `'.DB_PRE.'groups` AS groups JOIN `'.DB_PRE.'usergroup` AS usergroup ON groups.id = usergroup.gid WHERE usergroup.uid = ? ORDER BY groups.name');
	$dbs->execute(array($g_userid));
	$g_groups = $dbs->fetchAll();
}
catch (PDOException $e)
{
	$t_error = 'Datenbank-Fehler';
	require('error.template.php');
	
	if (DEBUG)
	{
		ob_start();
		print_r($e);
		echo nl2br(str_replace(' ','&nbsp;',htmlentities(ob_get_clean())));
	}
	exit;
}

require('header.template.php');

if ($g_mode == 'testlist')
{
	require('tests.template.php');
}
elseif ($g_mode == 'logs')
{
	require('logs.template.php');
}
elseif ($g_mode == 'settings')
{
	require('settings.template.php');
}

require('footer.template.php');
