<?php
if (!defined('INIT')) exit;
function pager_skip($act, $max, &$i, $padd=4)
{
	$width = 2*$padd+5;
	if ($max <= $width) return false;
	if ($i==1 and $act>=$padd+4)
	{
		$i = min($act-$padd-1,$max-$width+2);
		return true;
	}
	if ($i==max($act+$padd,$width-2) and $max-$i>=3)
	{
		$i = $max-1;
		return true;
	}
	return false;
}?>

<div class="parbox">
	<?php if ($t_show == 'errors' or $t_show == 'viewerror' or $t_show == 'delerror') { ?>
		<span class="parhead">Fehler</span>
	<?php } else { ?>
		<span class="parhead">Logs</span>
	<?php } ?>
	<div class="parbody">
		<?php if ($t_show == 'list') { ?>
			<?php if (!$t_filter_id) {
				foreach ($t_filter_types as $key=>$value) {
					if ($t_filter_type!=$key)
					{
						echo '<a href="./?logs';
						if ($key!='') echo '&type='.htmlspecialchars($key);
						echo '">'.htmlspecialchars($value).'</a> ';
					}
					else
					{
						echo htmlspecialchars($value).' ';
					}
				}
				echo '<br>';
			} ?>
			<?php if (!empty($t_log_list)) { ?>
				<form action="./?logs" method="post" accept-charset="utf-8">
					<?php if ($t_filter_id) { ?>
						<span class="iconlink">
							Filter: <?php echo htmlspecialchars($t_filter_name); ?>
							<a class="notextlink" href="./?logs" title="Filter entfernen"><img src="img/delete.png" alt="Filter entfernen"></a>
						</span>
					</span>
					<?php } ?>
					<table class="log">
							<tr><th colspan="<?php echo ($t_filter_id ? '2' : '3'); ?>">Aktion</th><th>Datum</th><th>Test</th></tr>
						<?php foreach ($t_log_list as $log) { ?>
							<tr style="<?php if ($log['error']) echo ' background-color:#ffbbb6;'; ?>">
								<td><input type="checkbox" name="files[]" value="<?php echo htmlspecialchars($log['id']); ?>"></td>
								<td><a class="notextlink" title="betrachten" href="<?php echo $log['link_view']; ?>"><img alt="betrachten" src="img/view.png"></a></td>
								<?php if (!$t_filter_id) { ?>
									<td><a class="notextlink" title="filtern" href="<?php echo $log['link_filter']; ?>"><img alt="filtern" src="img/filter.png"></a></td>
								<?php } ?>
								<td><?php echo htmlspecialchars(date($g_settings['dateformat'],$log['time'])); ?></td>
								<td><?php echo htmlspecialchars($log['title']); ?></td>
							</tr>
						<?php } ?>
					</table>
					<input type="checkbox" value="y" name="andolder"><label for="andolder">und alle älteren</label>
					<?php if ($t_page>1) {?>
						<input type="hidden" value="<?php echo htmlspecialchars($t_page); ?>" name="page">
					<?php }?>
					<?php if ($t_filter_id) {?>
						<input type="hidden" value="<?php echo htmlspecialchars($t_filter_id); ?>" name="id">
					<?php }?>
					<?php if ($t_filter_type) {?>
						<input type="hidden" value="<?php echo htmlspecialchars($t_filter_type); ?>" name="type">
					<?php }?>
					<input type="hidden" value="delete" name="laction">
					<input type="submit" value="Löschen" name="submit">
				</form>
			<?php } else { ?>
				Keine Logs vorhanden.
			<?php } ?>
			<?php if ($t_pages > 1) { ?>
				<div class="pager">
					<?php for ($i = 1; $i <= $t_pages; $i++) { 
						if ($i != $t_page) echo '<a href="./?logs&page='.$i.'"><span>'.$i.'</span></a>';
						else echo '<span class="pactive">'.$i.'</span>';
						if (pager_skip($t_page, $t_pages, $i)) echo '<span class="pskip">...</span>';
					} ?>
				</div>
			<?php } ?>
		<?php } elseif ($t_show == 'view') { ?>
			<span class="iconlink"><img src="img/back.png"><a href="<?php echo $t_backlink; ?>">zurück</a></span>
			<pre style="white-space: pre-wrap;">
<?php echo htmlspecialchars($t_content); ?>
			</pre>
			<span class="iconlink"><img src="img/back.png"><a href="<?php echo $t_backlink; ?>">zurück</a></span>
		<?php } elseif ($t_show == 'delete') { ?>
			<form action="<?php echo $t_backlink; ?>" method="post" accept-charset="utf-8">
				Wirklich diese(n) <?php echo htmlspecialchars($t_count); ?> Log(s) löschen?
				<input type="hidden" value="reallydel" name="laction">
				<input type="hidden" value="<?php echo htmlspecialchars($t_files); ?>" name="files">
				<input type="submit" value="Ja" name="confirmdelete">
				<input type="submit" value="Nein" name="abort" formnovalidate>
			</form>
		<?php } elseif ($t_show == 'errors') { ?>
			<?php if (!empty($t_fatal_errors)) { ?>
				<p>
					<?php foreach ($t_fatal_errors as $error) { ?>
						<a href="<?php echo htmlspecialchars($error['link']); ?>"><?php echo htmlspecialchars($error['title']); ?></a><br>
					<?php } ?>
				</p>
				<span class="iconlink"><img src="img/delete.png"><a href="./?logs=delerror">alle löschen</a></span>
			<?php } else { ?>
				Keine Fehlermeldungen vorhanden.
			<?php } ?>
		<?php } elseif ($t_show == 'errorview') { ?>
			<span class="iconlink"><img src="img/back.png"><a href="./?logs=errors">zurück</a></span>
			<pre style="white-space: pre-wrap;">
<?php echo htmlspecialchars($t_content); ?>
			</pre>
			<span class="iconlink"><img src="img/back.png"><a href="./?logs=errors">zurück</a></span>
		<?php } elseif ($t_show == 'errordel') { ?>
			<form action="./?logs=errors" method="post" accept-charset="utf-8">
				Wirklich alle Fehlermeldungen löschen?
				<input type="hidden" value="reallydelerror" name="laction">
				<input type="submit" value="Ja" name="confirmdelete">
				<input type="submit" value="Nein" name="abort" formnovalidate>
			</form>
		<?php } ?>
	</div>
</div>
