<?php
if (!defined('INIT')) exit;

$t_show = 'overview';
$use_post_values = FALSE;

$g_smtp_encryption_modes = array(
	'none' => 'keine',
	'starttls' => 'STARTTLS',
	'trystarttls' => 'STARTTLS wenn möglich',
	'ssl' => 'SSL',
	);
$g_smtp_authentication_modes = array(
	'none' => 'keine',
	'plain' => 'unverschlüsselt',
	);
	
$g_webliblist = array(
	'Curl-Multi'=>'webLibCurlMulti.php',
	'Curl-Easy'=>'webLibCurlEasy.php',
	'Simple'=>'webLibSimple.php',
	'None'=>'webLibNone.php'
	);


// ***********************
// * Eingabe verarbeiten *
// ***********************

if (isset($_POST['saction']))
{
	if  ($_POST['saction'] == 'newusersave' or $_POST['saction'] == 'editusersave')
	{
		$error = FALSE;
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Nutzerliste anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Nutzerliste anzeigen.
		if (!isset($_POST['confirmsave']) or !isset($_POST['username']) or !isset($_POST['password']) or !isset($_POST['password2']) or !$g_is_admin)
		{
			$error = TRUE;
		}
		elseif ($_POST['saction'] == 'editusersave')
		{
			if (!isset($_POST['uid']))
			{
				$error = TRUE;
			}
			else
			{
				// Keine Nutzer bearbeiten, die nicht existieren
				$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'user` WHERE id=?');
				$dbs->execute(array($_POST['uid']));
				if ($dbs->fetchColumn() == 0)
				{
					$t_warnings[] = 'Dieser Nutzer existiert nicht';
					$error = TRUE;
				}
			}
		}
		if ($error)
		{
			$t_show = 'userlist';
		}
		else
		{
			if (!isset($_POST['gsel'])) $_POST['gsel'] = array();
			
			// Die bisher geprüften Fehler haben Abbruch zur Folge
			// Nun wird auf Fehler geprüft, bei denen das Formular erneut gezeigt wird
			if (empty($_POST['username']))
			{
				$t_warnings[] = 'Kein Benutzername angegeben';
				$error = TRUE;
			}
			if ($_POST['password'] != $_POST['password2'])
			{
				$t_warnings[] = 'Es wurde nicht zwei mal das gleiche Passwort eingegeben';
				$error = TRUE;
			}
			elseif (empty($_POST['password']) and $_POST['saction'] == 'newusersave')
			{
				$t_warnings[] = 'Passwort darf nicht leer sein';
				$error = TRUE;
			}
			if (!$error) try
			{
				if ($_POST['saction'] == 'newusersave')
				{
					$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'user` (name, password) VALUES (?,?)');
					$dbs->execute(array($_POST['username'], hash_pw($_POST['password'])));
					$userid = $g_db->lastInsertId();
				}
				elseif (empty($_POST['password']))
				{
					// Passwort nicht ändern, wenn Passwortfeld leer
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'user` SET name=? WHERE id=?');
					$dbs->execute(array($_POST['username'], $_POST['uid']));
					$userid = $_POST['uid'];
				}
				else
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'user` SET name=?, password=? WHERE id=?');
					$dbs->execute(array($_POST['username'], hash_pw($_POST['password']), $_POST['uid']));
					$userid = $_POST['uid'];
				}
				// Wenn Nutzername schon vergeben, schlägt SQL-Befehl fehl -> weiter im catch-Block
				
				// Bisherige Gruppen des Nutzers ermitteln
				if ($_POST['saction'] == 'newusersave')
				{
					//Ein neuer Nutzer hat noch keine Gruppen
					$old_groups = array();
				}
				else
				{
					$dbs = $g_db->prepare('SELECT gid FROM `'.DB_PRE.'usergroup` WHERE uid=?');
					$dbs->execute(array($userid));
					$old_groups = $dbs->fetchAll(PDO::FETCH_COLUMN);
				}
				
				//Liste aller verfügbaren Gruppen ermitteln
				$dbs = $g_db->query('SELECT id FROM `'.DB_PRE.'groups`');
				$all_groups = $dbs->fetchAll(PDO::FETCH_COLUMN);
				
				//Nutzer zu Gruppen hinzufügen
				//Nicht zu Gruppen hinzufügen, in denen der Nutzer schon ist
				// oder die gar nicht existieren
				$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'usergroup` (uid, gid) VALUES (?, ?)');
				$add_groups = array_intersect(array_diff($_POST['gsel'], $old_groups), $all_groups);
				foreach($add_groups as $gid)
				{
					$dbs->execute(array($userid, $gid));
				}
				if ($_POST['saction'] == 'editusersave')
				// Ein neuer Nutzer ist in keiner Gruppe Mitglied, entfernen ist also nicht nötig.
				{
					//Nutzer aus Gruppen entfernen
					$delete_groups = array_diff($old_groups, $_POST['gsel']);
					if ($g_userid == $_POST['uid'])
					{
						//Nutzer darf sich nicht selbst aus der Admin-Gruppe entfernen
						$delete_groups = array_diff($delete_groups, array(0));
					}
					if (!empty($delete_groups))
					{
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'usergroup` WHERE uid=? AND gid IN '.in_statement($delete_groups,$g_db));
						$dbs->execute(array($_POST['uid']));
					}
				}
				
				// Login-Sperre entfernen
				if ($_POST['saction'] == 'editusersave' and !empty($_POST['remove_login_lock']))
				{
					$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'login_fail` WHERE username=?');
					$dbs->execute(array($_POST['username']));
				}
				
				$t_infos[] = 'Nutzer '.htmlspecialchars($_POST['username']).' gespeichert.';
				// Wenn ein Nutzer seinen eigenen Namen ändert, soll sich das sofort auswirken
				if ($_POST['saction'] == 'editusersave' and $g_userid == $_POST['uid'])
				{
					$g_username=$_POST['username'];
				}
				$t_show = 'userlist';
			}
			catch (PDOException $e)
			{
				// Wenn Code == 1062 (Duplicate Entry), dann wird 
				// die normale Fehlerbehandlung nicht durchgeführt
				if ($e->errorInfo[1]!=1062) throw $e;
				
				$t_warnings[] = 'Nutzername ist schon vergeben';
				$error = TRUE;
			}
			
			if ($error)
			{
				if ($_POST['saction'] == 'newusersave')
				{
					$t_show = 'newuser';
				}
				else
				{
					$t_show = 'edituser';
				}
				$use_post_values = TRUE;
			}
		}
	}
	elseif  ($_POST['saction'] == 'reallydeluser')
	{
		// Wenn $_POST['confirmdelete'] nicht gesetzt ist, dann wurde das Löschen
		// abgebrochen. In diesem Fall einfach Nutzerliste anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Nutzerliste anzeigen.
		$t_show = 'userlist';
		
		if (isset($_POST['confirmdelete']) and isset($_POST['uid']) and $g_is_admin)
		{
			$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'user` WHERE id=?');
			$dbs->execute(array($_POST['uid']));
			if ($deleteusername = $dbs->fetchColumn())
			{
				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'user` WHERE id=?');
				$dbs->execute(array($_POST['uid']));
				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'usergroup` WHERE uid=?');
				$dbs->execute(array($_POST['uid']));
				$t_infos[] = 'Nutzer '.$deleteusername.' wurde gelöscht.';
			}
			else
			{
				$t_warnings[] = 'Dieser Nutzer existiert nicht';
			}
		}
	}
	elseif  ($_POST['saction'] == 'newgroupsave' or $_POST['saction'] == 'editgroupsave')
	{
		$error = FALSE;
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Gruppenliste anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Gruppenliste anzeigen.
		if (!isset($_POST['confirmsave']) or !isset($_POST['groupname']) or !$g_is_admin)
		{
			$error = TRUE;
		}
		elseif ($_POST['saction'] == 'editgroupsave')
		{
			if (!isset($_POST['gid']))
			{
				$error = TRUE;
			}
			else
			{
				// Keine Gruppen bearbeiten, die nicht existieren
				$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'groups` WHERE id=?');
				$dbs->execute(array($_POST['gid']));
				if ($dbs->fetchColumn() == 0)
				{
					$t_warnings[] = 'Diese Gruppe existiert nicht';
					$error = TRUE;
				}
			}
		}
		if ($error)
		{
			$t_show = 'grouplist';
		}
		else
		{
			if (!isset($_POST['usel'])) $_POST['usel'] = array();
			// Die bisher geprüften Fehler haben Abbruch zur Folge
			// Nun wird auf Fehler geprüft, bei denen das Formular erneut gezeigt wird
			
			// Name der Admin-Gruppe kann nicht geändert werden
			if (empty($_POST['groupname']) and (!isset($_POST['gid']) or $_POST['gid'] != '0'))
			{
				$t_warnings[] = 'Kein Gruppenname angegeben';
				$error = TRUE;
			}
			
			if (!$error) try
			{
				if ($_POST['saction'] == 'newgroupsave')
				{
					$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'groups` (name, web_timeout, web_retries, web_redirects, web_check_statuscode, web_check_content, web_cert_check, mail_timeout, mail_send_via, notify_addr, notify_pause, notify_lastsent) VALUES (?,-1,-1,-1,-1,-1,-1,-1,-1,\'\',0,0)');
					$dbs->execute(array($_POST['groupname']));
					$groupid = $g_db->lastInsertId();
				}
				else
				{
					// Name der Admin-Gruppe kann nicht geändert werden
					if ($_POST['gid'] != '0')
					{
						$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'groups` SET name=? WHERE id=?');
						$dbs->execute(array($_POST['groupname'], $_POST['gid']));
					}
					$groupid = $_POST['gid'];
				}
				// Wenn Gruppenname schon vergeben, schlägt SQL-Befehl fehl -> weiter im catch-Block
				
				// Bisherige Nutzer der Gruppe ermitteln
				if ($_POST['saction'] == 'newgroupsave')
				{
					// Neue Gruppe hatte bisher keine Nutzer
					$old_users = array();
				}
				else
				{
					$dbs = $g_db->prepare('SELECT uid FROM `'.DB_PRE.'usergroup` WHERE gid=?');
					$dbs->execute(array($_POST['gid']));
					$old_users = $dbs->fetchAll(PDO::FETCH_COLUMN);
				}
				//Liste aller Nutzer ermitteln
				$dbs = $g_db->query('SELECT id FROM `'.DB_PRE.'user`');
				$all_users = $dbs->fetchAll(PDO::FETCH_COLUMN);
				
				//Nutzer zur Gruppe hinzufügen
				//Keine Nutzer zur Gruppe hinzugügen, die schon in der Gruppe sind
				// oder die gar nicht existieren
				$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'usergroup` (uid, gid) VALUES (?, ?)');
				$add_users = array_intersect(array_diff($_POST['usel'], $old_users), $all_users);
				foreach($add_users as $uid)
				{
					$dbs->execute(array($uid, $groupid));
				}
				
				if ($_POST['saction'] == 'editgroupsave')
				{
					//Nutzer aus der Gruppe entfernen
					//Bei einer neu angelegten Gruppe nicht nötig
					$delete_users = array_diff($old_users, $_POST['usel']);
					if ($_POST['gid'] == '0')
					{
						//Nutzer darf sich nicht selbst aus der Admin-Gruppe entfernen
						$delete_users = array_diff($delete_users, array($g_userid));
					}
					if (!empty($delete_users))
					{
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'usergroup` WHERE gid=? AND uid IN '.in_statement($delete_users,$g_db));
						$dbs->execute(array($_POST['gid']));
					}
				}
				
				$t_infos[] = 'Gruppe '.htmlspecialchars($_POST['groupname']).' gespeichert';
				$t_show = 'grouplist';
			}
			catch (PDOException $e)
			{
				// Wenn Code == 1062 (Duplicate Entry), dann wird 
				// die normale Fehlerbehandlung nicht durchgeführt
				if ($e->errorInfo[1]!=1062) throw $e;
				
				$t_warnings[] = 'Gruppenname ist schon vergeben';
				$error = TRUE;
			}
			
			if ($error)
			{
				if ($_POST['saction'] == 'newgroupsave')
				{
					$t_show = 'newgroup';
				}
				else
				{
					$t_show = 'editgroup';
				}
				$use_post_values = TRUE;
			}
		}
	}
	elseif  ($_POST['saction'] == 'reallydelgroup')
	{
		// Wenn $_POST['confirmdelete'] nicht gesetzt ist, dann wurde das Löschen
		// abgebrochen. In diesem Fall einfach Nutzerliste anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Nutzerliste anzeigen.
		$t_show = 'grouplist';
		
		if (isset($_POST['confirmdelete']) and isset($_POST['gid']) and $g_is_admin)
		{
			$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'groups` WHERE id=?');
			$dbs->execute(array($_POST['gid']));
			if ($deletegroupname = $dbs->fetchColumn())
			{
				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'webtest` WHERE `group`=?');
				$dbs->execute(array($_POST['gid']));

				$dbs = $g_db->prepare('SELECT id FROM `'.DB_PRE.'mailtest` WHERE `group`=?');
				$dbs->execute(array($_POST['gid']));
				$test_ids = $dbs->fetchAll(PDO::FETCH_COLUMN);
				foreach ($test_ids as $id)
				{
					$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sent` WHERE tid=?');
					$dbs->execute(array($id));
					$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sendto` WHERE tid=?');
					$dbs->execute(array($id));
					$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mailtest` WHERE id=?');
					$dbs->execute(array($id));
				}
				
				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'logs` WHERE `group`=?');
				$dbs->execute(array($_POST['gid']));
				
				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'usergroup` WHERE gid=?');
				$dbs->execute(array($_POST['gid']));

				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'groups` WHERE id=?');
				$dbs->execute(array($_POST['gid']));
				$t_infos[] = 'Gruppe '.$deletegroupname.' wurde gelöscht.';
			}
			else
			{
				$t_warnings[] = 'Diese Gruppe existiert nicht';
			}
		}
	}
	elseif  ($_POST['saction'] == 'editglobalsave')
	{
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Einstellungsseite anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Einstellungsseite anzeigen
		if (!isset($_POST['confirmsave']) or !isset($_POST['logintime']) or !isset($_POST['login_lock_time']) or !isset($_POST['login_lock_num']) or !isset($_POST['cronmin']) or !isset($_POST['cronmax']) or !isset($_POST['dateformat']) or !isset($_POST['weblib']) or !isset($_POST['pwcost']) or !isset($_POST['phpmail_from']) or !isset($_POST['siteurl']) or !$g_is_admin)
		{
			$t_show = 'overview';
		}
		else
		{
			$error = FALSE;
			if (!ctype_digit($_POST['logintime']) or $_POST['logintime'] == '0')
			{
				$t_warnings[] = 'Login-Dauer ist keine Zahl';
				$error = TRUE;
			}
			if (!ctype_digit($_POST['login_lock_num']) or $_POST['login_lock_num'] == '0')
			{
				$t_warnings[] = 'Login-Versuche ist keine Zahl';
				$error = TRUE;
			}
			if (!ctype_digit($_POST['login_lock_time']) or $_POST['login_lock_time'] == '0')
			{
				$t_warnings[] = 'Login-Sperrdauer ist keine Zahl';
				$error = TRUE;
			}
			if (!ctype_digit($_POST['cronmin']))
			{
				$t_warnings[] = 'Pause zwischen zwei Prüfungen ist keine Zahl';
				$error = TRUE;
			}
			if (!ctype_digit($_POST['cronmax']))
			{
				$t_warnings[] = 'Cronjob-Alarm ist keine Zahl';
				$error = TRUE;
			}
			if (empty($_POST['dateformat']))
			{
				$t_warnings[] = 'Datumsformat darf nicht leer sein';
				$error = TRUE;
			}
			if (!in_array($_POST['weblib'], array('webLibCurlMulti.php', 'webLibCurlEasy.php', 'webLibSimple.php', 'webLibNone.php')))
			{
				$t_warnings[] = 'Ungültige Webtest-Methode';
				$error = TRUE;
			}
			if (!ctype_digit($_POST['pwcost']) or $_POST['pwcost'] < 4 or $_POST['pwcost'] > 31)
			{
				$t_warnings[] = 'Passwort-Faktor muss eine Zahl im Bereich 4-31 sein';
				$error = TRUE;
			}
			$phpmail_from_char_error = FALSE;
			$len = strlen($_POST['phpmail_from']);
			for ($i = 0; $i < $len; $i++)
			{
				if (ord($_POST['phpmail_from'][$i]) <= 31 or ord($_POST['phpmail_from'][$i]) >= 127)
				{
					$phpmail_from_char_error = TRUE;
				}
			}
			if (!preg_match(perl_regex(SINGLE_MAIL_PATTERN),$_POST['phpmail_from']) or $phpmail_from_char_error)
			{
				$t_warnings[] = 'Geben sie eine gültige Absenderadresse an';
				$error = TRUE;
			}
			if ($error)
			{
				$t_show = 'globalsettings';
				$use_post_values = TRUE;
			}
			else
			{
				$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'settings` SET value=? WHERE `key`=?');
				$dbs->execute(array($_POST['logintime']*60,'logintime'));
				$dbs->execute(array($_POST['login_lock_num'],'login_lock_num'));
				$dbs->execute(array($_POST['login_lock_time']*60,'login_lock_time'));
				$dbs->execute(array($_POST['cronmin']*60,'cronmin'));
				$dbs->execute(array($_POST['cronmax']*60,'cronmax'));
				$dbs->execute(array($_POST['dateformat'],'dateformat'));
				$dbs->execute(array($_POST['weblib'],'weblib'));
				$dbs->execute(array(sprintf('%02d',$_POST['pwcost']),'pwcost'));
				$dbs->execute(array($_POST['phpmail_from'],'phpmail_from'));
				$dbs->execute(array($_POST['siteurl'],'siteurl'));
				$t_infos[] = 'Globale Einstellungen gespeichert.';
				$t_show = 'overview';
			}
		}
	}
	elseif  ($_POST['saction'] == 'editgroupsettsave')
	{
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Einstellungsseite anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Einstellungsseite anzeigen
		if (!isset($_POST['confirmsave']) or
			!isset($_POST['urltimeout_d']) or
			($_POST['urltimeout_d'] == '0' and !isset($_POST['urltimeout'])) or
			!isset($_POST['urlretries_d']) or
			($_POST['urlretries_d'] == '0' and !isset($_POST['urlretries'])) or
			!isset($_POST['urlredirects_d']) or
			($_POST['urlredirects_d'] == '0' and !isset($_POST['urlredirects'])) or
			!isset($_POST['urlcheckstatuscode_d']) or
			!isset($_POST['urlcheckcontent_d']) or
			!isset($_POST['urlcertcheck_d']) or
			!isset($_POST['mail_timeout_d']) or
			($_POST['mail_timeout_d'] == '0' and !isset($_POST['mail_timeout'])) or
			!isset($_POST['mail_send_via_d']) or
			($_POST['mail_send_via_d'] == '0' and !isset($_POST['mail_send_via'])) or 
			!isset($_POST['notify_addr']) or
			!isset($_POST['notify_pause'])
			)
		{
			$t_show = 'overview';
		}
		else
		{
			$error = FALSE;
			if ($_POST['urltimeout_d'] == '0' and (!ctype_digit($_POST['urltimeout']) or $_POST['urltimeout'] == '0'))
			{
				$t_warnings[] = 'Web-Zeitlimit ist keine Zahl';
				$error = TRUE;
			}
			if ($_POST['urlretries_d'] == '0' and !ctype_digit($_POST['urlretries']))
			{
				$t_warnings[] = 'Wiederholungen ist keine Zahl';
				$error = TRUE;
			}
			if ($_POST['mail_timeout_d'] == '0' and (!ctype_digit($_POST['mail_timeout']) or $_POST['mail_timeout'] == '0'))
			{
				$t_warnings[] = 'Mail-Zeitlimit ist keine Zahl';
				$error = TRUE;
			}
			
			// Keinen SMTP-Server verwenden, der nicht existiert
			if ($_POST['mail_send_via_d'] == '0' and $_POST['mail_send_via'] != '0')
			{
				//Versand per SMTP
				$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'smtp` WHERE id=? and `group`=?');
				$dbs->execute(array($_POST['mail_send_via'], $g_active_group));
				if ($dbs->fetchColumn() == 0)
				{
					$t_warnings[] = 'Dieser SMTP-Server existiert nicht';
					$error = TRUE;
				}
			}

			if (!preg_match(perl_regex(MAIL_PATTERN),$_POST['notify_addr']) and !empty($_POST['notify_addr']))
			{
				// Dieses Feld darf leer bleiben, dann werden keine Warnungen verschickt.
				$t_warnings[] = 'Geben Sie die Emailadressen als kommagetrennte Liste an';
				$error = TRUE;
			}
			
			if (empty($_POST['notify_addr']) and $g_active_group==0)
			{
				$t_warnings[] = 'Für die Admin-Gruppe muss mindestens eine Emailadresse angegeben werden';
				$error = TRUE;
			}
			
			if (!ctype_digit($_POST['notify_pause']))
			{
				$t_warnings[] = 'Abstand ist keine Zahl';
				$error = TRUE;
			}
			
			if ($error)
			{
				$t_show = 'groupsettings';
				$use_post_values = TRUE;
				if (!isset($_POST['urltimeout'])) $_POST['urltimeout'] = '';
				if (!isset($_POST['urlretries'])) $_POST['urlretries'] = '';
				if (!isset($_POST['urlredirects'])) $_POST['urlredirects'] = '';
				if (!isset($_POST['urlcertcheck'])) $_POST['urlcertcheck'] = '';
				if (!isset($_POST['mail_timeout'])) $_POST['mail_timeout'] = '';
				if (!isset($_POST['mail_send_via'])) $_POST['mail_send_via'] = '0';
			}
			else
			{
				// Alles ok, speichern

				$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'groups` SET web_timeout=?, web_retries=?, web_redirects=?, web_check_statuscode=?, web_check_content=?, web_cert_check=?, mail_timeout=?, mail_send_via=?, notify_addr=?, notify_pause=? WHERE id=?');
				$dbs->execute(array(
					$_POST['urltimeout_d'] == '0' ? $_POST['urltimeout'] : '-1',
					$_POST['urlretries_d'] == '0' ? $_POST['urlretries'] : '-1',
					$_POST['urlredirects_d'] == '0' ? $_POST['urlredirects'] : '-1',
					$_POST['urlcheckstatuscode_d'] == '0' ? (int)isset($_POST['urlcheckstatuscode']) : '-1',
					$_POST['urlcheckcontent_d'] == '0' ? (int)isset($_POST['urlcheckcontent']) : '-1',
					$_POST['urlcertcheck_d'] == '0' ? (int)isset($_POST['urlcertcheck']) : '-1',
					$_POST['mail_timeout_d'] == '0' ? $_POST['mail_timeout']*60 : '-1',
					$_POST['mail_send_via_d'] == '0' ? $_POST['mail_send_via'] : '-1',
					$_POST['notify_addr'],
					$_POST['notify_pause']*60,
					$g_active_group,
				));
				$t_infos[] = 'Einstellungen für Gruppe '.htmlspecialchars($g_active_group_name).' gespeichert.';
				$t_show = 'overview';
			}
		}
	}
	elseif  ($_POST['saction'] == 'editprivatesave')
	{
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Einstellungsseite anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Einstellungsseite anzeigen.
		if (!isset($_POST['confirmsave']) or !isset($_POST['password']) or !isset($_POST['password2']))
		{
			$t_show = 'overview';
		}
		else
		{
			{
				$error = FALSE;
				if ($_POST['password'] != $_POST['password2'])
				{
					$t_warnings[] = 'Es wurde nicht zwei mal das gleiche Passwort eingegeben';
					$error = TRUE;
				}
				elseif (empty($_POST['password']))
				{
					$t_warnings[] = 'Passwort darf nicht leer sein';
					$error = TRUE;
				}
				else
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'user` SET password=? WHERE id=?');
					$dbs->execute(array(hash_pw($_POST['password']), $g_userid));
	
					$t_infos[] = 'Eigene Einstellungen gespeichert.';
					$t_show = 'overview;';
				}
				if ($error)
				{
					$t_show = 'privatesettings';
				}
			}
		}
	}
	elseif  ($_POST['saction'] == 'newsmtpsave' or $_POST['saction'] == 'editsmtpsave')
	{
		$error = FALSE;
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach SMTP-Liste anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// SMTP-Liste anzeigen.
		if (!isset($_POST['confirmsave']) or !isset($_POST['name']) or !isset($_POST['addr']) or !isset($_POST['port']) or !isset($_POST['encryption']) or !isset($g_smtp_encryption_modes[$_POST['encryption']]) or !isset($_POST['authentication']) or !isset($g_smtp_authentication_modes[$_POST['authentication']]) or !isset($_POST['username']) or !isset($_POST['comment']) or !isset($_POST['password']) or !isset($_POST['password2']) or !isset($_POST['sender']) or !$g_is_admin)
		{
			$error = TRUE;
		}
		elseif ($_POST['saction'] == 'editsmtpsave')
		{
			if (!isset($_POST['sid']))
			{
				$error = TRUE;
			}
			else
			{
				// Keine Server bearbeiten, die nicht existieren
				$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'smtp` WHERE id=? and `group`=?');
				$dbs->execute(array($_POST['sid'], $g_active_group));
				if ($dbs->fetchColumn() == 0)
				{
					$t_warnings[] = 'Dieser SMTP-Server existiert nicht';
					$error = TRUE;
				}
			}
		}
		if ($error)
		{
			$t_show = 'smtplist';
		}
		else
		{
			// Die bisher geprüften Fehler haben Abbruch zur Folge
			// Nun wird auf Fehler geprüft, bei denen das Formular erneut gezeigt wird
			if (empty($_POST['name']))
			{
				$t_warnings[] = 'Keine Bezeichnung angegeben';
				$error = TRUE;
			}
			if (empty($_POST['addr']))
			{
				$t_warnings[] = 'Keine Serveradresse angegeben';
				$error = TRUE;
			}
			if (empty($_POST['port']))
			{
				$t_warnings[] = 'Kein Port angegeben';
				$error = TRUE;
			}
			if (empty($_POST['username']) and $_POST['authentication'] != 'none')
			{
				$t_warnings[] = 'Wählen sie Autentifizierung: keine oder geben sie einen Benutzernamen an.';
				$error = TRUE;
			}
			if ($_POST['password'] != $_POST['password2'])
			{
				$t_warnings[] = 'Es wurde nicht zwei mal das gleiche Passwort eingegeben';
				$error = TRUE;
			}
			elseif (empty($_POST['password']) and $_POST['saction'] == 'newsmtpsave' and $_POST['authentication'] != 'none')
			{
				$t_warnings[] = 'Wählen sie Autentifizierung: keine oder geben sie ein Passwort an.';
				$error = TRUE;
			}
			elseif (!preg_match(perl_regex(SINGLE_MAIL_PATTERN),$_POST['sender']))
			{
				$t_warnings[] = 'Geben sie eine gültige Absenderadresse an';
				$error = TRUE;
			}
			if (!$error) try
			{
				if ($_POST['saction'] == 'newsmtpsave')
				{
					$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'smtp` (name, `group`, addr, port, encryption, authentication, username, password, comment, certcheck, sender) VALUES (?,?,?,?,?,?,?,?,?,?,?)');
					$dbs->execute(array(
						$_POST['name'],
						$g_active_group,
						$_POST['addr'],
						$_POST['port'],
						$_POST['encryption'],
						$_POST['authentication'],
						$_POST['username'],
						$_POST['password'],
						$_POST['comment'],
						(int)isset($_POST['certcheck']),
						$_POST['sender'],
						));
				}
				elseif (empty($_POST['password']))
				{
					// Passwort nicht ändern, wenn Passwortfeld leer
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'smtp` SET name=?, `group`=?, addr=?, port=?, encryption=?, authentication=?, username=?, comment=?, certcheck=?, sender=? WHERE id=?');
					$dbs->execute(array(
						$_POST['name'],
						$g_active_group,
						$_POST['addr'],
						$_POST['port'],
						$_POST['encryption'],
						$_POST['authentication'],
						$_POST['username'],
						$_POST['comment'],
						(int)isset($_POST['certcheck']),
						$_POST['sender'],
						$_POST['sid'],
						));
				}
				else
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'smtp` SET name=?, `group`=?, addr=?, port=?, encryption=?, authentication=?, username=?, password=?, comment=?, certcheck=?, sender=? WHERE id=?');
					$dbs->execute(array(
						$_POST['name'],
						$g_active_group,
						$_POST['addr'],
						$_POST['port'],
						$_POST['encryption'],
						$_POST['authentication'],
						$_POST['username'],
						$_POST['password'],
						$_POST['comment'],
						(int)isset($_POST['certcheck']),
						$_POST['sender'],
						$_POST['sid'],
						));
				}
				// Wenn Nutzername schon vergeben, schlägt SQL-Befehl fehl -> weiter im catch-Block
				
				$t_infos[] = 'SMTP-Server '.htmlspecialchars($_POST['name']).' gespeichert.';
				$t_show = 'smtplist';
			}
			catch (PDOException $e)
			{
				// Wenn Code == 1062 (Duplicate Entry), dann wird 
				// die normale Fehlerbehandlung nicht durchgeführt
				if ($e->errorInfo[1]!=1062) throw $e;
				
				$t_warnings[] = 'Bezeichnung ist schon vergeben';
				$error = TRUE;
			}
			
			if ($error)
			{
				$use_post_values = TRUE;
				if ($_POST['saction'] == 'newsmtpsave')
				{
					$t_show = 'newsmtp';
				}
				else
				{
					$t_show = 'editsmtp';
				}
			}
		}
	}
	elseif  ($_POST['saction'] == 'reallydelsmtp')
	{
		// Wenn $_POST['confirmdelete'] nicht gesetzt ist, dann wurde das Löschen
		// abgebrochen. In diesem Fall einfach Nutzerliste anzeigen
		// Wenn Daten aus Eingabefeldern fehlen, wurde manipuliert. Auch dann 
		// Nutzerliste anzeigen.
		$t_show = 'smtplist';
		
		if (isset($_POST['confirmdelete']) and isset($_POST['sid']) and $g_is_admin)
		{
			$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'smtp` WHERE id=?');
			$dbs->execute(array($_POST['sid']));
			if ($deletesmtpname = $dbs->fetchColumn())
			{
				
				$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'mailtest` SET send_via=-1 WHERE send_via=?');
				$dbs->execute(array($_POST['sid']));
				$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'groups` SET mail_send_via=-1 WHERE mail_send_via=?');
				$dbs->execute(array($_POST['sid']));
				$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'smtp` WHERE id=?');
				$dbs->execute(array($_POST['sid']));
				$t_infos[] = 'SMTP-Server '.htmlspecialchars($deletesmtpname).' wurde gelöscht.';
			}
			else
			{
				$t_warnings[] = 'Dieser SMTP-Server existiert nicht';
			}
		}
	}
}
else
{
	if ($_GET['settings'] == 'users' and $g_is_admin)
	{
		$t_show = 'userlist';
	}
	elseif ($_GET['settings'] == 'groups' and $g_is_admin)
	{
		$t_show = 'grouplist';
	}
	elseif ($_GET['settings'] == 'newuser' and $g_is_admin)
	{
		$t_show = 'newuser';
	}
	elseif ($_GET['settings'] == 'newgroup' and $g_is_admin)
	{
		$t_show = 'newgroup';
	}
	elseif ($_GET['settings'] == 'edituser' and isset($_GET['uid']) and $g_is_admin)
	{
		// Keine Nutzer bearbeiten, die nicht existieren
		$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'user` WHERE id=?');
		$dbs->execute(array($_GET['uid']));
		if ($dbs->fetchColumn() == 0)
		{
			$t_warnings[] = 'Dieser Nutzer existiert nicht';
			$t_show = 'userlist';
		}
		else
		{
			$t_show = 'edituser';
		}
	}
	elseif ($_GET['settings'] == 'editgroup' and isset($_GET['gid']) and $g_is_admin)
	{
		// Keine Gruppen bearbeiten, die nicht existieren
		$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'groups` WHERE id=?');
		$dbs->execute(array($_GET['gid']));
		if ($dbs->fetchColumn() == 0)
		{
			$t_warnings[] = 'Diese Gruppe existiert nicht';
			$t_show = 'grouplist';
		}
		else
		{
			$t_show = 'editgroup';
		}
	}
	elseif  ($_GET['settings'] == 'deluser' and isset($_GET['uid']) and $g_is_admin)
	{
		// Keine Nutzer löschen, die nicht existieren
		$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'user` WHERE id=?');
		$dbs->execute(array($_GET['uid']));
		if ($dbs->fetchColumn() == 0)
		{
			$t_warnings[] = 'Dieser Nutzer existiert nicht';
			$t_show = 'userlist';
		}
		elseif ($_GET['uid'] == $g_userid)
		{
			$t_warnings[] = 'Der aktuelle Nutzer kann nicht gelöscht werden.';
			$t_show = 'userlist';
		}
		else
		{
			$t_show = 'deluser';
			$deluser = $_GET['uid'];
		}
	}
	elseif  ($_GET['settings'] == 'delgroup' and isset($_GET['gid']) and $g_is_admin)
	{
		// Keine Gruppen löschen, die nicht existieren
		$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'groups` WHERE id=?');
		$dbs->execute(array($_GET['gid']));
		if ($dbs->fetchColumn() == 0)
		{
			$t_warnings[] = 'Diese Gruppe existiert nicht';
			$t_show = 'grouplist';
		}
		elseif ($_GET['gid'] == '0')
		{
			$t_warnings[] = 'Die Admin-Gruppe kann nicht gelöscht werden';
			$t_show = 'grouplist';
		}
		else
		{
			$t_show = 'delgroup';
			$delgroup = $_GET['gid'];
		}
	}
	elseif ($_GET['settings'] == 'global' and $g_is_admin)
	{
		$t_show = 'globalsettings';
	}
	elseif ($_GET['settings'] == 'activegroup' and $g_is_admin)
	{
		$t_show = 'groupsettings';
	}
	elseif ($_GET['settings'] == 'private')
	{
		$t_show = 'privatesettings';
	}
	elseif ($_GET['settings'] == 'smtp')
	{
		$t_show = 'smtplist';
	}
	elseif ($_GET['settings'] == 'newsmtp' and $g_is_admin)
	{
		$t_show = 'newsmtp';
	}
	elseif ($_GET['settings'] == 'editsmtp' and isset($_GET['sid']) and $g_is_admin)
	{
		// Keinen SMTP-Server verwenden, der nicht existiert
		$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'smtp` WHERE id=? and `group`=?');
		$dbs->execute(array($_GET['sid'], $g_active_group));
		if ($dbs->fetchColumn() == 0)
		{
			$t_warnings[] = 'Dieser SMTP-Server existiert nicht';
			$t_show = 'smtplist';
		}
		else
		{
			$t_show = 'editsmtp';
		}
	}
	elseif  ($_GET['settings'] == 'delsmtp' and isset($_GET['sid']) and $g_is_admin)
	{
		// Keinen SMTP-Server löschen, der nicht existiert
		$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'smtp` WHERE id=? and `group`=?');
		$dbs->execute(array($_GET['sid'], $g_active_group));
		if ($dbs->fetchColumn() == 0)
		{
			$t_warnings[] = 'Dieser SMTP-Server existiert nicht';
			$t_show = 'smtplist';
		}
		else
		{
			$t_show = 'delsmtp';
		}
	}
	elseif ($_GET['settings'] == 'info')
	{
		$t_show = 'info';
	}
}


// ***********************
// * Ausgabe vorbereiten *
// ***********************



if ($t_show == 'userlist')
{
	$dbs = $g_db->prepare('SELECT u.id, u.name, COUNT(g.gid) as isadmin FROM `'.DB_PRE.'user` AS u LEFT JOIN `'.DB_PRE.'usergroup` AS g ON u.id=g.uid AND g.gid=0 GROUP BY u.id ORDER BY name');
	$dbs->execute();
	$t_user_list = $dbs->fetchAll();
	foreach ($t_user_list as &$value)
	{
		// Nutzer darf sich nicht selbst löschen
		if ($g_userid == $value['id'])
		{
			$value['may_delete'] = FALSE;
		}
		else
		{
			$value['may_delete'] = TRUE;
		}
	}
	unset($value);
}
elseif ($t_show == 'grouplist')
{
	$dbs = $g_db->prepare('SELECT id, name, (id != 0) AS may_delete FROM `'.DB_PRE.'groups` ORDER BY name');
	$dbs->execute();
	$t_group_list = $dbs->fetchAll();
}
elseif ($t_show == 'newuser')
{
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$t_user['newname'] = '';
		$dbs = $g_db->query('SELECT id, name, 0 AS useringroup, 1 AS may_change FROM `'.DB_PRE.'groups` ORDER BY name');
		$t_user['groups'] = $dbs->fetchAll();
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$t_user['newname'] = $_POST['username'];
		$dbs = $g_db->query('SELECT id, name, 1 AS may_change FROM `'.DB_PRE.'groups` ORDER BY name');
		$t_user['groups'] = $dbs->fetchAll();
		foreach ($t_user['groups'] as &$value)
		{
			$value['useringroup'] = in_array($value['id'],$_POST['gsel']);
		}
		unset($value);
	}
	$t_user['has_login_lock'] = false;
}
elseif ($t_show == 'newgroup')
{
	$t_group['name_may_change'] = TRUE;
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$t_group['newname'] = '';
		$dbs = $g_db->query('SELECT id, name, 0 AS useringroup, 1 AS may_change FROM `'.DB_PRE.'user` ORDER BY name');
		$t_group['users'] = $dbs->fetchAll();
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$t_group['newname'] = $_POST['groupname'];
		$dbs = $g_db->query('SELECT id, name, 1 AS may_change FROM `'.DB_PRE.'user` ORDER BY name');
		$t_group['users'] = $dbs->fetchAll();
		foreach ($t_group['users'] as &$value)
		{
			$value['useringroup'] = in_array($value['id'],$_POST['usel']);
		}
		unset($value);
	}
}
elseif ($t_show == 'edituser')
{
	$dbs = $g_db->prepare('SELECT user.id AS uid, user.name AS oldname, COUNT(DISTINCT login_fail.count) AS has_login_lock FROM `'.DB_PRE.'user` AS user LEFT JOIN `'.DB_PRE.'login_fail` AS login_fail ON user.name=login_fail.username AND login_fail.expire>? WHERE user.id=?');
	
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$dbs->execute(array(time(), $_GET['uid']));
		$t_user = $dbs->fetch();
		$t_user['newname'] = $t_user['oldname'];
		$dbs = $g_db->prepare('SELECT groups.id, groups.name, COUNT(DISTINCT usergroup.uid) AS useringroup FROM `'.DB_PRE.'groups` AS groups LEFT JOIN `'.DB_PRE.'usergroup` AS usergroup ON groups.id = usergroup.gid AND usergroup.uid=? GROUP BY groups.id ORDER BY groups.name');
		$dbs->execute(array($t_user['uid']));
		$t_user['groups'] = $dbs->fetchAll();
		$t_user['remove_login_lock'] = false;
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$dbs->execute(array(time(), $_POST['uid']));
		$t_user = $dbs->fetch();
		$t_user['newname'] = $_POST['username'];
		$dbs = $g_db->prepare('SELECT id, name FROM `'.DB_PRE.'groups` ORDER BY name');
		$dbs->execute();
		$t_user['groups'] = $dbs->fetchAll();
		foreach ($t_user['groups'] as &$value)
		{
			$value['useringroup'] = in_array($value['id'],$_POST['gsel']);
		}
		unset($value);
		$t_user['remove_login_lock'] = isset($_POST['remove_login_lock']);
	}
	foreach ($t_user['groups'] as &$value)
	{
		// Nutzer darf sich nicht selbst die Admin-Rechte nehmen
		if ($g_userid == $t_user['uid'] and $value['id'] == 0)
		{
			$value['may_change'] = FALSE;
			// Ein Nutzer, der Nutzer bearbeiten kann, muss Mitglied
			// der Admin-Gruppe sein. Weil die Checkbox disabled ist, ging diese
			// Information verloren.
			$value['useringroup'] = TRUE;
		}
		else
		{
			$value['may_change'] = TRUE;
		}
	}
	unset($value);
}
elseif ($t_show == 'editgroup')
{
	$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'groups` WHERE id=?');
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$t_group['gid'] = $_GET['gid'];
		$dbs->execute(array($t_group['gid']));
		$t_group['newname'] = $t_group['oldname'] = $dbs->fetchColumn();
		$dbs = $g_db->prepare('SELECT user.id, user.name, COUNT(DISTINCT usergroup.gid) AS useringroup FROM `'.DB_PRE.'user` AS user LEFT JOIN `'.DB_PRE.'usergroup` AS usergroup ON user.id = usergroup.uid AND usergroup.gid=? GROUP BY user.id ORDER BY user.name');
		$dbs->execute(array($t_group['gid']));
		$t_group['users'] = $dbs->fetchAll();
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$t_group['gid'] = $_POST['gid'];
		$dbs->execute(array($t_group['gid']));
		$t_group['oldname'] = $dbs->fetchColumn();
		$t_group['newname'] = $_POST['groupname'];
		$dbs = $g_db->prepare('SELECT id, name FROM `'.DB_PRE.'user` ORDER BY name');
		$dbs->execute();
		$t_group['users'] = $dbs->fetchAll();
		foreach ($t_group['users'] as &$value)
		{
			$value['useringroup'] = in_array($value['id'],$_POST['usel']);
		}
		unset($value);
	}
	$t_group['name_may_change'] = ($t_group['gid'] != 0);
	foreach ($t_group['users'] as &$value)
	{
		// Nutzer darf sich nicht selbst die Admin-Rechte nehmen
		if ($g_userid == $value['id'] and $t_group['gid'] == 0)
		{
			$value['may_change'] = FALSE;
			// Ein Nutzer, der Gruppen bearbeiten kann, muss Mitglied
			// der Admin-Gruppe sein. Weil die Checkbox disabled ist, ging diese
			// Information verloren.
			$value['useringroup'] = TRUE;
		}
		else
		{
			$value['may_change'] = TRUE;
		}
	}
	unset($value);
}
elseif ($t_show == 'deluser')
{
	$t_user['uid'] = $deluser;
	$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'user` WHERE id=?');
	$dbs->execute(array($deluser));
	$t_user['name'] = $dbs->fetchColumn();
}
elseif ($t_show == 'delgroup')
{
	$t_group['gid'] = $delgroup;
	$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'groups` WHERE id=?');
	$dbs->execute(array($delgroup));
	$t_group['name'] = $dbs->fetchColumn();
}
elseif ($t_show == 'globalsettings')
{
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$t_global_settings = $g_settings;
		$t_global_settings['logintime'] = (int)($t_global_settings['logintime']/60);
		$t_global_settings['login_lock_time'] = (int)($t_global_settings['login_lock_time']/60);
		$t_global_settings['cronmin'] = (int)($t_global_settings['cronmin']/60);
		$t_global_settings['cronmax'] = (int)($t_global_settings['cronmax']/60);
		$t_global_settings['pwcost'] = ltrim($t_global_settings['pwcost'],'0');
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$t_global_settings['logintime'] = $_POST['logintime'];
		$t_global_settings['login_lock_time'] = $_POST['login_lock_time'];
		$t_global_settings['login_lock_num'] = $_POST['login_lock_num'];
		$t_global_settings['cronmin'] = $_POST['cronmin'];
		$t_global_settings['cronmax'] = $_POST['cronmax'];
		$t_global_settings['dateformat'] = $_POST['dateformat'];
		$t_global_settings['pwcost'] = $_POST['pwcost'];
		$t_global_settings['weblib'] = $_POST['weblib'];
		$t_global_settings['phpmail_from'] = $_POST['phpmail_from'];
		$t_global_settings['siteurl'] = $_POST['siteurl'];
	}
}
elseif ($t_show == 'groupsettings')
{
	// Standardwerte laden
	// Werte der Admin-Gruppe sind Standard für alle anderen Gruppen
	if ($g_active_group != 0)
	{
		$dbs = $g_db->query('SELECT web_timeout, web_retries, web_redirects, web_check_statuscode, web_check_content, web_cert_check, mail_timeout, mail_send_via FROM `'.DB_PRE.'groups` WHERE id=0 ORDER BY id');
		while ($row = $dbs->fetch())
		{
			foreach ($row as $key=>$value)
			{
				if ($value != -1)
				{
					$g_default_values[$key] = $value;
				}
			}
		}
	}
	$g_default_values['mail_timeout_minutes'] = (int)($g_default_values['mail_timeout']/60);
	
	$dbs = $g_db->prepare('SELECT id, CONCAT(\'SMTP: \',name) AS name FROM `'.DB_PRE.'smtp` WHERE `group`=? ORDER BY name');
	$dbs->execute(array($g_active_group));
	$t_smtp_list = array_merge(array(array('id'=>0,'name'=>'PHP-mail')),$dbs->fetchAll());

	// Name des Standard-Mailversands in $g_default_values['mail_send_via_name'] speichern
	// Standardwert ist eventuell nicht in $t_smtp_list enthalten
	// in diesem Fall 'Globaler SMTP' anzeigen.
	$g_default_values['mail_send_via_name'] = 'Globaler SMTP';
	foreach($t_smtp_list as $item)
	{
		if ($g_default_values['mail_send_via']==$item['id'])
		{
			$g_default_values['mail_send_via_name'] = $item['name'];
			break;
		}
	}

	if (!$use_post_values)
	{
		 //Erster Bearbeitungsversuch
		$dbs = $g_db->prepare('SELECT web_timeout, web_retries, web_redirects, web_check_statuscode, web_check_content, web_cert_check, mail_timeout, mail_send_via, notify_addr, notify_pause FROM `'.DB_PRE.'groups` WHERE `id`=?');
		$dbs->execute(array($g_active_group));
		$row = $dbs->fetch();

		$t_group_settings = array(
			'web_timeout' => ($row['web_timeout'] == -1) ? '' : htmlspecialchars($row['web_timeout']),
			'web_timeout_d' => ($row['web_timeout'] == -1),
			'web_retries' => ($row['web_retries'] == -1) ? '' : htmlspecialchars($row['web_retries']),
			'web_retries_d' => ($row['web_retries'] == -1),
			'web_redirects' => ($row['web_redirects'] == -1) ? '' : htmlspecialchars($row['web_redirects']),
			'web_redirects_d' => ($row['web_redirects'] == -1),
			'web_checkstatuscode' => ($row['web_check_statuscode'] == 1),
			'web_checkstatuscode_d' => ($row['web_check_statuscode'] == -1),
			'web_checkcontent' => ($row['web_check_content'] == 1),
			'web_checkcontent_d' => ($row['web_check_content'] == -1),
			'web_certcheck' => ($row['web_cert_check'] == 1),
			'web_certcheck_d' => ($row['web_cert_check'] == -1),

			'mail_timeout' => ($row['mail_timeout'] == -1) ? '' : htmlspecialchars((int)($row['mail_timeout']/60)),
			'mail_timeout_d' => ($row['mail_timeout'] == -1),
			'mail_send_via' => ($row['mail_send_via'] == -1) ? 0 : $row['mail_send_via'],
			'mail_send_via_d' => ($row['mail_send_via'] == -1),

			'notify_addr' => htmlspecialchars($row['notify_addr']),
			'notify_pause' => htmlspecialchars((int)($row['notify_pause']/60)),
			);
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		// Notwendige POST-Variablen sind alle vorhanden, das wurde geprüft
		$t_group_settings = array(
			'web_timeout' => htmlspecialchars($_POST['urltimeout']),
			'web_timeout_d' => ($_POST['urltimeout_d'] == '1'),
			'web_retries' => htmlspecialchars($_POST['urlretries']),
			'web_retries_d' => ($_POST['urlretries_d'] == '1'),
			'web_redirects' => htmlspecialchars($_POST['urlredirects']),
			'web_redirects_d' => ($_POST['urlredirects_d'] == '1'),
			'web_checkstatuscode' => isset($_POST['urlcheckstatuscode']),
			'web_checkstatuscode_d' => ($_POST['urlcheckstatuscode_d'] == '1'),
			'web_checkcontent' => isset($_POST['urlcheckcontent']),
			'web_checkcontent_d' => ($_POST['urlcheckcontent_d'] == '1'),
			'web_certcheck' => isset($_POST['urlcertcheck']),
			'web_certcheck_d' => ($_POST['urlcertcheck_d'] == '1'),
			'mail_timeout' => htmlspecialchars($_POST['mail_timeout']),
			'mail_timeout_d' => ($_POST['mail_timeout_d'] == '1'),
			'mail_send_via' => htmlspecialchars($_POST['mail_send_via']),
			'mail_send_via_d' => ($_POST['mail_send_via_d'] == '1'),
			'notify_addr' => htmlspecialchars($_POST['notify_addr']),
			'notify_pause' => htmlspecialchars($_POST['notify_pause']),
			);
	}
}
elseif ($t_show == 'smtplist')
{
	$dbs = $g_db->prepare('SELECT id, name, CONCAT(addr,\':\',port) AS server, username, comment FROM `'.DB_PRE.'smtp` WHERE `group`=? ORDER BY name');
	$dbs->execute(array($g_active_group));
	$t_smtp_list = $dbs->fetchAll();
}
elseif ($t_show == 'newsmtp')
{
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$t_smtp = array(
			'newname' => '',
			'addr' => '',
			'port' => '',
			'encryption' => '',
			'authentication' => '',
			'username' => '',
			'comment' => '',
			'certcheck' => true,
			'sender' => '',
			);
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$t_smtp = array(
			'newname' => $_POST['name'],
			'addr' => $_POST['addr'],
			'port' => $_POST['port'],
			'encryption' => $_POST['encryption'],
			'authentication' => $_POST['authentication'],
			'username' => $_POST['username'],
			'comment' => $_POST['comment'],
			'certcheck' => isset($_POST['certcheck']),
			'sender' => $_POST['sender'],
			);
	}
}
elseif ($t_show == 'editsmtp')
{
	if (!$use_post_values)
	{
		// Erster Bearbeitungsversuch
		$dbs = $g_db->prepare('SELECT name, `group`, addr, port, encryption, authentication, username, comment, certcheck, sender FROM `'.DB_PRE.'smtp` WHERE id=?');
		$dbs->execute(array($_GET['sid']));
		$row = $dbs->fetch();
		$t_smtp = array(
			'sid' => $_GET['sid'],
			'oldname' => $row['name'],
			'newname' => $row['name'],
			'addr' => $row['addr'],
			'port' => $row['port'],
			'encryption' => $row['encryption'],
			'authentication' => $row['authentication'],
			'username' => $row['username'],
			'comment' => $row['comment'],
			'certcheck' => $row['certcheck'],
			'sender' => $row['sender'],
			);
	}
	else
	{
		// Fehlerhafte Eingaben, Formular erneut anzeigen
		$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'smtp` WHERE id=?');
		$dbs->execute(array($_POST['sid']));
		$row = $dbs->fetch();
		$t_smtp = array(
			'sid' => $_POST['sid'],
			'oldname' => $row['name'],
			'newname' => $_POST['name'],
			'addr' => $_POST['addr'],
			'port' => $_POST['port'],
			'encryption' => $_POST['encryption'],
			'authentication' => $_POST['authentication'],
			'username' => $_POST['username'],
			'comment' => $_POST['comment'],
			'certcheck' => isset($_POST['certcheck']),
			'sender' => $_POST['sender'],
			);
	}

}
elseif ($t_show == 'delsmtp')
{
	$t_smtp['sid'] = $_GET['sid'];
	$dbs = $g_db->prepare('SELECT name FROM `'.DB_PRE.'smtp` WHERE id=?');
	$dbs->execute(array($_GET['sid']));
	$t_smtp['name'] = $dbs->fetchColumn();
	$dbs = $g_db->prepare('SELECT mail_send_via FROM `'.DB_PRE.'groups` WHERE id=?');
	$dbs->execute(array($g_active_group));
	$t_smtp['group_default'] = ($dbs->fetchColumn() == $_GET['sid']);
	$dbs = $g_db->prepare('SELECT COUNT(id) FROM `'.DB_PRE.'mailtest` WHERE `group`=? AND send_via=?');
	$dbs->execute(array($g_active_group, $_GET['sid']));
	$t_smtp['use_count'] = $dbs->fetchColumn();
}
elseif ($t_show == 'info')
{
	$t_info_list = array(
		array('name'=>'Rosmarin-Version', 'value'=>VERSION),
		array('name'=>'PHP-Version', 'value'=>PHP_VERSION),
		);

	$weblibname = '';
	foreach ($g_webliblist as $name=>$value)
	{
		if ($value == $g_settings['weblib'])
			$weblibname = $name;
	}
	$t_info_list[] = array('name'=>'Webtest-Methode', 'value'=>$weblibname);

	//$dbs = $g_db->query('SELECT s.name, s.username, s.addr, s.port FROM `'.DB_PRE.'groups` AS g JOIN `'.DB_PRE.'smtp` AS s ON g.mail_send_via=s.id WHERE g.id=0');
	//$smtpname = $dbs->fetch();
	//if (!$smtpname)
		//$smtpname='keiner';
	//else
		//$smtpname = sprintf('%s (%s / %s:%s)', $smtpname['name'], $smtpname['username'], $smtpname['addr'], $smtpname['port']);
	//$t_info_list[] = array('name'=>'globaler SMTP', 'value'=>$smtpname);
	
	$t_info_list[] = array('name'=>'letzte Prüfung', 'value'=>date($g_settings['dateformat'],$g_settings['cronlast']));
}

