<?php
if (!defined('INIT')) exit;

class navi
{
	private $navtree = array(
		'einstellung' => array('h'=>'./?settings', 't'=>'Einstellungen'),
		'nutzer' => array('h'=>'./?settings=users', 't'=>'Nutzer verwalten', 'p'=>'einstellung'),
		'nutzerb' => array('h'=>'./?settings=users', 't'=>'Nutzer ', 'p'=>'nutzer'),
		'nutzerneu' => array('h'=>'./?settings=newuser', 't'=>'Nutzer anlegen', 'p'=>'nutzer'),
		'gruppen' => array('h'=>'./?settings=groups', 't'=>'Gruppen verwalten', 'p'=>'einstellung'),
		'gruppenb' => array('h'=>'./?settings=groups', 't'=>'Gruppe ', 'p'=>'gruppen'),
		'gruppeneu' => array('h'=>'./?settings=newgroup', 't'=>'Gruppe anlegen', 'p'=>'gruppen'),
		'global' => array('h'=>'./?settings=global', 't'=>'Globale Einstellungen', 'p'=>'einstellung'),
		'eigene' => array('h'=>'./?settings=private', 't'=>'Eigene Einstellungen', 'p'=>'einstellung'),
		'gr_einstellung' => array('h'=>'./?settings=activegroup', 't'=>'Gruppeneinstellungen', 'p'=>'einstellung'),
		'gr_einstellung_' => array('h'=>'./?settings=activegroup', 't'=>'Einstellungen für Gruppe ', 'p'=>'einstellung'),
		'smtp' => array('h'=>'./?settings=smtp', 't'=>'SMTP-Server', 'p'=>'einstellung'),
		'smtp_' => array('h'=>'./?settings=smtp', 't'=>'SMTP-Server für Gruppe ', 'p'=>'einstellung'),
		'smtpb' => array('h'=>'./?settings=smtp', 't'=>'SMTP-Server ', 'p'=>'smtp'),
		'smtpneu' => array('h'=>'./?settings=newsmtp', 't'=>'SMTP-Server anlegen ', 'p'=>'smtp'),
		'info' => array('h'=>'./?settings=info', 't'=>'Server-Informationen', 'p'=>'einstellung'),
	);

	public function url($name)
	{
		echo $this->navtree[$name]['h'];
	}

	public function link($name, $add='')
	{
		echo '<a href="'.$this->navtree[$name]['h'].'">'.$this->navtree[$name]['t'].$add.'</a>';
	}

	public function link_chain($name, $add='')
	{
		$str = $this->navtree[$name]['t'].$add;
		while (isset($this->navtree[$name]['p']))
		{
			$name = $this->navtree[$name]['p'];
			$str= '<a href="'.$this->navtree[$name]['h'].'">'.$this->navtree[$name]['t'].'</a> › '.$str;
		}
		echo $str;
	}
}
$navi = new navi();
?>
<div class="parbox">
	<span class="parhead">Einstellungen</span>
	<div class="parbody">
		<?php if ($t_show == 'overview') { ?>
			<?php if ($g_is_admin) { ?>
				<p class="shead">Administration</p>
				<span class="iconlink"><img alt="" src="img/user.png"><?php $navi->link('nutzer'); ?></span><br/>
				<span class="iconlink"><img alt="" src="img/group.png"><?php $navi->link('gruppen'); ?></span><br/>
				<span class="iconlink"><img alt="" src="img/settings.png"><?php $navi->link('global'); ?></span>
			<?php } ?>
			<p class="shead">aktive Gruppe: <?php echo htmlspecialchars($g_active_group_name); ?></p>
			<span class="iconlink"><img alt="" src="img/group_settings.png"><?php $navi->link('gr_einstellung'); ?></span><br />
			<span class="iconlink"><img alt="" src="img/smtp.png"><?php $navi->link('smtp'); ?></span>
			<p class="shead">sonstiges</p>
			<span class="iconlink"><img alt="" src="img/information.png"><?php $navi->link('info'); ?></span><br />
			<span class="iconlink"><img alt="" src="img/user_settings.png"><?php $navi->link('eigene'); ?></span>
		<?php } elseif ($t_show == 'userlist') { ?>
			<div class="shead"><?php $navi->link_chain('nutzer'); ?></div>
			<ul class="slist">
				<?php foreach ($t_user_list as $user) { ?>
					<li class="iconlink<?php if ($user['isadmin']) echo ' admingrp'; ?>">
						<?php echo htmlspecialchars($user['name']); ?> <a class="notextlink" title="bearbeiten" href="./?settings=edituser&uid=<?php echo htmlspecialchars($user['id']); ?>"><img alt="bearbeiten" src="img/edit.png"></a><?php if ($user['may_delete']) { ?><a class="notextlink" title="löschen" href="./?settings=deluser&uid=<?php echo htmlspecialchars($user['id']); ?>"><img alt="löschen" src="img/delete.png"></a><?php } ?>
					</li>
				<?php } ?>
			</ul>
			<span class="iconlink"><img alt="" src="img/back.png"><a href="./?settings">zurück</a></span>
			<span class="iconlink"><img alt="" src="img/new.png"><a href="./?settings=newuser">Neuen Nutzer anlegen</a></span>
		<?php } elseif ($t_show == 'grouplist') { ?>
			<div class="shead"><?php $navi->link_chain('gruppen'); ?></div>
			<ul class="slist">
				<?php foreach ($t_group_list as $group) { ?>
					<li class="iconlink<?php if ($group['id'] == 0) echo ' admingrp'; ?>">
						<?php echo htmlspecialchars($group['name']); ?> <a class="notextlink" title="bearbeiten" href="./?settings=editgroup&gid=<?php echo htmlspecialchars($group['id']); ?>"><img alt="bearbeiten" src="img/edit.png"></a><?php if ($group['may_delete']) { ?><a class="notextlink" title="löschen" href="./?settings=delgroup&gid=<?php echo htmlspecialchars($group['id']); ?>"><img alt="löschen" src="img/delete.png"></a><?php } ?>
					</li>
				<?php } ?>
			</ul>
			<span class="iconlink"><img alt="" src="img/back.png"><a href="./?settings">zurück</a></span>
			<span class="iconlink"><img alt="" src="img/new.png"><a href="./?settings=newgroup">Neue Gruppe anlegen</a></span>
		<?php } elseif ($t_show == 'edituser' or $t_show == 'newuser') { ?>
			<div class="shead"><?php ($t_show == 'edituser') ? $navi->link_chain('nutzerb', htmlspecialchars($t_user['oldname'])) : $navi->link_chain('nutzerneu'); ?></div>
			<form action="./?settings=users" method="post" accept-charset="utf-8">
				<table>
					<tr><td><label for="username">Name:</label></td><td><input type="text" name="username" size="50" value="<?php echo htmlspecialchars($t_user['newname']) ?>" /></td></tr>
					<tr><td><label for="password">Passwort:</label></td><td><input type="password" name="password" <?php if ($t_show == 'edituser') {?>placeholder="Nur ausfüllen, wenn Sie das Passwort ändern möchten" <?php } ?>size="50"/></td></tr> 
					<tr><td><label for="password2">Passwort:</label></td><td><input type="password" name="password2" placeholder="Passwort wiederholen" size="50"/></td></tr> 
					<tr><td class="cblistlabel"><label for="gsel[]">Gruppen:</label></td>
						<td><ul class="cblist">
							<?php foreach ($t_user['groups'] as $group) { ?>
								<li>
									<input type="checkbox" name="gsel[]" value="<?php echo htmlspecialchars($group['id']) ?>" <?php echo ($group['useringroup']) ? 'checked ' : '' ?><?php echo ($group['may_change']) ? '' : 'disabled ' ?>/><?php echo htmlspecialchars($group['name']) ?>
								</li>
							<?php 	} ?>
						</ul></td>
					</tr>
					<?php if ($t_show == 'edituser') { ?>
						<tr><td><label for="remove_login_lock">Login-Sperre<br>entfernen:</label></td><td><input type="checkbox" name="remove_login_lock" value="y" <?php if (!$t_user['has_login_lock']) echo 'disabled '; ?><?php if ($t_user['remove_login_lock']) echo 'checked '; ?>/></td></tr> 
					<?php } ?>
				</table>
				<?php if ($t_show == 'edituser') { ?>
					<input type="hidden" name="uid" value="<?php echo htmlspecialchars($t_user['uid']) ?>" />
					<input type="hidden" name="saction" value="editusersave" />
				<?php } else { ?>
					<input type="hidden" name="saction" value="newusersave" />
				<?php } ?>
				<input type="submit" value="Ok" name="confirmsave">
				<input type="submit" value="Abbrechen" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'deluser') { ?>
			<div class="shead"><?php $navi->link_chain('nutzerb', htmlspecialchars($t_user['name'])); ?></div>
			<form action="./?settings=users" method="post" accept-charset="utf-8">
				Nutzer <?php echo htmlspecialchars($t_user['name']); ?> wirklich löschen?<br>
				<input type="hidden" name="uid" value="<?php echo htmlspecialchars($t_user['uid']) ?>" />
				<input type="hidden" name="saction" value="reallydeluser" />
				<input type="submit" value="Ja" name="confirmdelete">
				<input type="submit" value="Nein" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'editgroup' or $t_show == 'newgroup') { ?>
			<div class="shead"><?php ($t_show == 'editgroup') ? $navi->link_chain('gruppenb', htmlspecialchars($t_group['oldname'])) : $navi->link_chain('gruppeneu'); ?></div>
			<form action="./?settings=groups" method="post" accept-charset="utf-8">
				<table>
					<tr><td><label for="groupname">Name:</label></td><td><input type="text" name="groupname" size="50" value="<?php echo htmlspecialchars($t_group['newname']) ?>" <?php echo ($t_group['name_may_change']) ? '' : 'readonly ' ?>/></td></tr>
					<tr><td class="cblistlabel"><label for="usel[]">Nutzer:</label></td>
						<td><ul class="cblist">
							<?php foreach ($t_group['users'] as $user) { ?>
								<li>
									<input type="checkbox" name="usel[]" value="<?php echo htmlspecialchars($user['id']) ?>" <?php echo ($user['useringroup']) ? 'checked ' : '' ?><?php echo ($user['may_change']) ? '' : 'disabled ' ?>/><?php echo htmlspecialchars($user['name']) ?>
								</li>
							<?php } ?>
						</ul></td>
					</tr>
				</table>
				<?php if ($t_show == 'editgroup') { ?>
					<input type="hidden" name="gid" value="<?php echo htmlspecialchars($t_group['gid']) ?>" />
					<input type="hidden" name="saction" value="editgroupsave" />
				<?php } else { ?>
					<input type="hidden" name="saction" value="newgroupsave" />
				<?php } ?>
				<input type="submit" value="Ok" name="confirmsave">
				<input type="submit" value="Abbrechen" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'delgroup') { ?>
			<div class="shead"><?php $navi->link_chain('gruppenb', htmlspecialchars($t_group['name'])); ?></div>
			<form action="./?settings=groups" method="post" accept-charset="utf-8">
				Gruppe <?php echo htmlspecialchars($t_group['name']); ?> wirklich löschen?<br>Damit werden auch alle Tests und Logeinträge dieser Gruppe gelöscht.<br>
				<input type="hidden" name="gid" value="<?php echo htmlspecialchars($t_group['gid']) ?>" />
				<input type="hidden" name="saction" value="reallydelgroup" />
				<input type="submit" value="Ja" name="confirmdelete">
				<input type="submit" value="Nein" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'globalsettings') { ?>
			<div class="shead"><?php $navi->link_chain('global'); ?></div>
			<form action="./?settings=global" method="post" accept-charset="utf-8">
				<label for="logintime">Login-Dauer:</label> <input type="text" name="logintime" size="8" value="<?php echo htmlspecialchars($t_global_settings['logintime']) ?>" /> Minuten
				<div class="explain">Zeit, nach der ein inaktiver Nutzer automatisch abgemeldet wird</div>
				<label for="login_lock_num">Login-Versuche:</label> <input type="text" name="login_lock_num" size="8" value="<?php echo htmlspecialchars($t_global_settings['login_lock_num']) ?>" />
				<div class="explain">Anzahl an fehlgeschlagenen Loginversuchen, bei der ein Nutzername vorübergehend blockiert wird.</div>
				<label for="login_lock_time">Login-Sperrdauer:</label> <input type="text" name="login_lock_time" size="8" value="<?php echo htmlspecialchars($t_global_settings['login_lock_time']) ?>" /> Minuten
				<div class="explain">Zeit, nach der ein Nutzer wieder einen Loginversuch hat</div>
				<label for="cronmin">Pause zwischen zwei Prüfungen:</label> <input type="text" name="cronmin" size="8" value="<?php echo htmlspecialchars($t_global_settings['cronmin']) ?>" /> Minuten
				<div class="explain">Zeit, die nach einer Cronjob-Prüfung vergehen muss, bis erneut eine Prüfung ausgeführt wird.</div>
				<label for="cronmax">Cronjob-Alarm:</label> <input type="text" name="cronmax" size="8" value="<?php echo htmlspecialchars($t_global_settings['cronmax']) ?>" /> Minuten
				<div class="explain">Warnen, wenn zwischen zwei Cronjob-Aufrufen mehr als die angegebene Zeit vergangen ist.</div>
				<label for="dateformat">Datumsformat:</label> <input type="text" name="dateformat" size="16" value="<?php echo htmlspecialchars($t_global_settings['dateformat']) ?>" /> („<?php echo htmlspecialchars($t_global_settings['dateformat']); ?>“ entspricht „<?php echo date($g_settings['dateformat']); ?>“)
				<div class="explain">Format für Datumsangaben (z.B. d.m.Y H:i:s).</div>
				<label for="pwcost">Passwort-Kostenfaktor:</label> <input type="text" name="pwcost" size="8" value="<?php echo htmlspecialchars($t_global_settings['pwcost']) ?>" />
				<div class="explain">Verschlüsselungsstärke für die Passwörter.</div>
				<label for="weblib">Webtest-Methode:</label> <select name="weblib" size="1">
					<?php foreach ($g_webliblist as $name=>$value) { ?>
						<option value="<?php echo $value; ?>"<?php if ($value == $t_global_settings['weblib']) echo ' selected'; ?>><?php echo $name; ?></option>
					<?php } ?>
				</select>
				<div class="explain">Methode, mit der Webseiten zur Überprüfung abgerufen werden.</div>
				<label for="phpmail_from">PHP-Mail-Absender:</label> <input type="text" name="phpmail_from" size="50" value="<?php echo htmlspecialchars($t_global_settings['phpmail_from']) ?>" />
				<div class="explain">Absenderadresse für die Benutzung der PHP-eigenen mail()-Funktion.</div>
				<label for="siteurl">URL:</label> <input type="text" name="siteurl" size="50" value="<?php echo htmlspecialchars($t_global_settings['siteurl']) ?>" />
				<div class="explain">URL, unter der Rosmarin erreichbar ist.</div>
				<input type="hidden" name="saction" value="editglobalsave" />
				<input type="submit" value="Ok" name="confirmsave">
				<input type="submit" value="Abbrechen" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'groupsettings') { ?>
			<div class="shead"><?php $navi->link_chain('gr_einstellung_',htmlspecialchars($g_active_group_name)); ?></div>
			<?php if ($g_active_group == 0) { ?>
				<b>Achtung: Die Einstellungen der Admingruppe werden als Standardwerte für die anderen Gruppen verwendet.</b>
			<?php } ?>
			<form action="./?settings=activegroup" method="post" accept-charset="utf-8">
				<div class="shead2">Web-Tests</div>
				<table class="testsettings sub">
					<tr>
						<td><label class="desc" for="urltimeout">Zeitlimit:</label></td>
						<td><input class="radio_default" type="radio" name="urltimeout_d" value="1" <?php if ($t_group_settings['web_timeout_d']) echo 'checked'; ?>/> Standard (<?php echo $g_default_values['web_timeout']; ?>)</td>
						<td><input class="radio_default" type="radio" name="urltimeout_d" value="0" <?php if (!$t_group_settings['web_timeout_d']) echo 'checked'; ?>/>
						<input type="text" size="8" name="urltimeout" value="<?php echo $t_group_settings['web_timeout']; ?>"/> Sekunden</td>
					</tr>
					<tr>
						<td><label class="desc" for="urlretries">Wiederholungen:</label></td>
						<td><input class="radio_default" type="radio" name="urlretries_d" value="1" <?php if ($t_group_settings['web_retries_d']) echo 'checked'; ?>/> Standard (<?php echo $g_default_values['web_retries']; ?>)</td>
						<td><input class="radio_default" type="radio" name="urlretries_d" value="0" <?php if (!$t_group_settings['web_retries_d']) echo 'checked'; ?>/>
						<input type="text" size="8" name="urlretries" value="<?php echo $t_group_settings['web_retries']; ?>"/></td>
					</tr>
					<tr>
						<td><label class="desc" for="urlredirects">Weiterleitungen:</label></td>
						<td><input class="radio_default" type="radio" name="urlredirects_d" value="1" <?php if ($t_group_settings['web_redirects_d']) echo 'checked'; ?>/> Standard (<?php echo $g_default_values['web_redirects']; ?>)</td>
						<td><input class="radio_default" type="radio" name="urlredirects_d" value="0" <?php if (!$t_group_settings['web_redirects_d']) echo 'checked'; ?>/>
						<input type="text" size="8" name="urlredirects" value="<?php echo $t_group_settings['web_redirects']; ?>"/></td>
					</tr>
					<tr>
						<td><label for="urlcheckstatuscode">Statuscode prüfen:</label></td>
						<td><input class="radio_default" type="radio" name="urlcheckstatuscode_d" value="1" <?php if ($t_group_settings['web_checkstatuscode_d']) echo 'checked'; ?>/> Standard (<?php echo yesno($g_default_values['web_check_statuscode']); ?>)</td>
						<td><input class="radio_default" type="radio" name="urlcheckstatuscode_d" value="0" <?php if (!$t_group_settings['web_checkstatuscode_d']) echo 'checked'; ?>/>
						<input type="checkbox" name="urlcheckstatuscode" <?php if($t_group_settings['web_checkstatuscode']) echo 'checked '; ?>/></td>
					</tr>
					<tr>
						<td><label for="urlcheckcontent">Inhalt prüfen:</label></td>
						<td><input class="radio_default" type="radio" name="urlcheckcontent_d" value="1" <?php if ($t_group_settings['web_checkcontent_d']) echo 'checked'; ?>/> Standard (<?php echo yesno($g_default_values['web_check_content']); ?>)</td>
						<td><input class="radio_default" type="radio" name="urlcheckcontent_d" value="0" <?php if (!$t_group_settings['web_checkcontent_d']) echo 'checked'; ?>/>
						<input type="checkbox" name="urlcheckcontent" <?php if($t_group_settings['web_checkcontent']) echo 'checked '; ?>/></td>
					</tr>
					<tr>
						<td><label for="urlcertcheck">SSL-Zertifikat prüfen:</label></td>
						<td><input class="radio_default" type="radio" name="urlcertcheck_d" value="1" <?php if ($t_group_settings['web_certcheck_d']) echo 'checked'; ?>/> Standard (<?php echo yesno($g_default_values['web_cert_check']); ?>)</td>
						<td><input class="radio_default" type="radio" name="urlcertcheck_d" value="0" <?php if (!$t_group_settings['web_certcheck_d']) echo 'checked'; ?>/>
						<input type="checkbox" name="urlcertcheck" <?php if($t_group_settings['web_certcheck']) echo 'checked '; ?>/></td>
					</tr>
				</table>
				<div class="shead2">Mailtests</div>
				<table class="testsettings sub">
					<tr>
						<td><label class="desc" for="mail_timeout">Zeitlimit:</label></td>
						<td><input class="radio_default" type="radio" name="mail_timeout_d" value="1" <?php if ($t_group_settings['mail_timeout_d']) echo 'checked'; ?>/> Standard (<?php echo $g_default_values['mail_timeout_minutes']; ?>)</td>
						<td><input class="radio_default" type="radio" name="mail_timeout_d" value="0" <?php if (!$t_group_settings['mail_timeout_d']) echo 'checked'; ?>/>
						<input type="text" size="8" name="mail_timeout" value="<?php echo $t_group_settings['mail_timeout']; ?>"/> Minuten</td>
					</tr>
					<tr>
						<td><label class="desc" for="mail_send_via">Mailversand:</label></td>
						<td><input class="radio_default" type="radio" name="mail_send_via_d" value="1" <?php if ($t_group_settings['mail_send_via_d']) echo 'checked'; ?>/> Standard (<?php echo $g_default_values['mail_send_via_name']; ?>)</td>
						<td><input class="radio_default" type="radio" name="mail_send_via_d" value="0" <?php if (!$t_group_settings['mail_send_via_d']) echo 'checked'; ?>/>
						<select size="1" name="mail_send_via">
							<?php foreach ($t_smtp_list as $item) { ?>
								<option value="<?php echo htmlspecialchars($item['id']); ?>"<?php if ($t_group_settings['mail_send_via']==$item['id']) echo ' selected'; ?>><?php echo htmlspecialchars($item['name']); ?></option>
							<?php } ?>
						</select></td>
					</tr>
				</table>
				<div class="shead2">Warnung per Mail</div>
				<table class="testsettings sub">
					<tr>
						<td><label for="notify_addr">Warnungen an:</label></td>
						<td><input type="text" pattern="<?php echo MAIL_PATTERN; ?>" title="Eine oder mehrere Emailadresseen mit Komma getrennt" name="notify_addr" size="50" value="<?php echo $t_group_settings['notify_addr']; ?>"></td>
					</tr>
					<tr>
						<td><label for="notify_pause">Abstand:</label></td>
						<td colspan="2"><input type="text" name="notify_pause" size="8" value="<?php echo $t_group_settings['notify_pause']; ?>">Minuten</td>
					</tr>
				</table>
				<input type="hidden" name="saction" value="editgroupsettsave" />
				<input type="submit" value="Ok" name="confirmsave">
				<input type="submit" value="Abbrechen" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'privatesettings') { ?>
			<div class="shead"><?php $navi->link_chain('eigene'); ?></div>
			<form action="./?settings=private" method="post" accept-charset="utf-8">
				<table>
					<tr><td><label for="password">Passwort:</label></td><td><input type="password" name="password" placeholder="Passwort" size="50"/></td></tr> 
					<tr><td><label for="password2">Passwort:</label></td><td><input type="password" name="password2" placeholder="Passwort wiederholen" size="50"/></td></tr> 
				</table>
				<input type="hidden" name="saction" value="editprivatesave" />
				<input type="submit" value="Ok" name="confirmsave">
				<input type="submit" value="Abbrechen" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'smtplist') { ?>
			<div class="shead"><?php $navi->link_chain('smtp_',htmlspecialchars($g_active_group_name)); ?></div>
			<?php foreach ($t_smtp_list as $item) { ?>
				<div class="smtpbox">
					<table>
						<tr><td rowspan="4"><a class="notextlink" title="bearbeiten" href="./?settings=editsmtp&sid=<?php echo htmlspecialchars($item['id']); ?>"><img alt="bearbeiten" src="img/edit.png"></a><br><a class="notextlink" title="löschen" href="./?settings=delsmtp&sid=<?php echo htmlspecialchars($item['id']); ?>"><img alt="löschen" src="img/delete.png"></a></td><td>Bezeichnung:</td><td><?php echo htmlspecialchars($item['name']); ?></td></tr> 
						<tr><td>Server:</td><td><?php echo htmlspecialchars($item['server']); ?></td></tr> 
						<tr><td>Nutzername:</td><td><?php echo htmlspecialchars($item['username']); ?></td></tr> 
						<?php if (!empty($item['comment'])) { ?>
							<tr><td>Anmerkung:</td><td><?php echo htmlspecialchars($item['comment']); ?></td></tr>
						<?php } ?>
					</table>
				</div>
			<?php } ?>
			<span class="iconlink"><img alt="" src="img/back.png"><a href="./?settings">zurück</a></span>
			<span class="iconlink"><img alt="" src="img/new.png"><a href="./?settings=newsmtp">Neuen SMTP-Server anlegen</a></span>
		<?php } elseif ($t_show == 'editsmtp' or $t_show == 'newsmtp') { ?>
			<div class="shead"><?php ($t_show == 'editsmtp') ? $navi->link_chain('smtpb', htmlspecialchars($t_smtp['oldname'])) : $navi->link_chain('smtpneu'); ?></div>
			<form action="./?settings=smtp" method="post" accept-charset="utf-8">
				<table>
					<tr><td><label for="name">Bezeichnung:</label></td><td><input type="text" name="name" size="50" value="<?php echo htmlspecialchars($t_smtp['newname']) ?>" /></td></tr>
					<tr><td><label for="addr">Adresse:</label></td><td><input type="text" name="addr" size="50" value="<?php echo htmlspecialchars($t_smtp['addr']) ?>" /></td></tr>
					<tr><td><label for="port">Port:</label></td><td><input type="text" name="port" size="10" value="<?php echo htmlspecialchars($t_smtp['port']) ?>" /></td></tr>
					<tr><td><label for="encryption">Verschlüsselung:</label></td><td><select name="encryption">
						<?php foreach ($g_smtp_encryption_modes as $code=>$name) { ?>
							<option value="<?php echo htmlspecialchars($code); ?>"<?php if ($code == $t_smtp['encryption']) echo ' selected'; ?>><?php echo htmlspecialchars($name); ?></option>
						<?php } ?>
					</select></td></tr>
					<tr><td><label for="authentication">Autentifizierung:</label></td><td><select name="authentication" >
						<?php foreach ($g_smtp_authentication_modes as $code=>$name) { ?>
							<option value="<?php echo htmlspecialchars($code); ?>"<?php if ($code == $t_smtp['authentication']) echo ' selected'; ?>><?php echo htmlspecialchars($name); ?></option>
						<?php } ?>
					</select></td></tr>
					<tr><td><label for="certcheck">Zertifikat überprüfen:</label></td><td><input type="checkbox" name="certcheck" value="y"<?php if ($t_smtp['certcheck']) echo ' checked'; ?> /></td></tr>
					<tr><td><label for="username">Nutzername:</label></td><td><input type="text" name="username" size="50" value="<?php echo htmlspecialchars($t_smtp['username']) ?>" /></td></tr>
					<tr><td><label for="password">Passwort:</label></td><td><input type="password" name="password" <?php if ($t_show == 'editsmtp') {?>placeholder="Nur ausfüllen, wenn Sie das Passwort ändern möchten" <?php } ?>size="50"/></td></tr> 
					<tr><td><label for="password2">Passwort:</label></td><td><input type="password" name="password2" placeholder="Passwort wiederholen" size="50"/></td></tr> 
					<tr><td><label for="sender">Absender:</label></td><td><input type="text" pattern="<?php echo SINGLE_MAIL_PATTERN; ?>" title="Eine Emailadresse" name="sender" size="50" value="<?php echo htmlspecialchars($t_smtp['sender']) ?>" /></td></tr> 
					<tr><td><label for="comment">Anmerkung:</label></td><td><input type="text" name="comment" size="50" value="<?php echo htmlspecialchars($t_smtp['comment']) ?>" /></td></tr>
				</table>
				<?php if ($t_show == 'editsmtp') { ?>
					<input type="hidden" name="sid" value="<?php echo htmlspecialchars($t_smtp['sid']) ?>" />
					<input type="hidden" name="saction" value="editsmtpsave" />
				<?php } else { ?>
					<input type="hidden" name="saction" value="newsmtpsave" />
				<?php } ?>
				<input type="submit" value="Ok" name="confirmsave">
				<input type="submit" value="Abbrechen" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'delsmtp') { ?>
			<div class="shead"><?php $navi->link_chain('smtpb', htmlspecialchars($t_smtp['name'])); ?></div>
			<form action="./?settings=smtp" method="post" accept-charset="utf-8">
			<form action="./?settings=smtp" method="post" accept-charset="utf-8">
				SMTP-Server <?php echo htmlspecialchars($t_smtp['name']); ?> wirklich löschen?<br />
				Hinweis: Dieser SMTP-Server ist <?php echo $t_smtp['group_default'] ? '' : '<b>nicht</b> '; ?>Gruppenstandard.<br/>
				Hinweis: Dieser SMTP-Server ist für <?php echo htmlspecialchars($t_smtp['use_count']); ?> Mail-Test(s) explizit als SMTP-Server festgelegt.<br/>
				<input type="hidden" name="sid" value="<?php echo htmlspecialchars($t_smtp['sid']) ?>" />
				<input type="hidden" name="saction" value="reallydelsmtp" />
				<input type="submit" value="Ja" name="confirmdelete">
				<input type="submit" value="Nein" name="abort" formnovalidate>
			</form>	
		<?php } elseif ($t_show == 'info') { ?>
			<div class="shead"><?php $navi->link_chain('info'); ?></div>
			<table class="log">
				<?php foreach ($t_info_list as $item) { ?>
					<tr>
						<td><?php echo htmlspecialchars($item['name']); ?>:</td>
						<td>
							<?php echo htmlspecialchars($item['value']); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
			<span class="iconlink"><img alt="" src="img/back.png"><a href="./?settings">zurück</a></span>
		<?php } ?>
	</div>
</div>
