<?php
if (!defined('INIT')) exit;
$t_show = 'normal';
$web_ids = array();
$mail_ids = array();
$success_count = 0;

// Standardwerte laden
$dbs = $g_db->prepare('SELECT web_timeout, web_retries, web_redirects, web_check_statuscode, web_check_content, web_cert_check, mail_timeout, mail_send_via FROM `'.DB_PRE.'groups` WHERE id=0 or id=? ORDER BY id');
$dbs->execute(array($g_active_group));
while ($row = $dbs->fetch())
{
	foreach ($row as $key=>$value)
	{
		if ($value != -1)
		{
			$g_default_values[$key] = $value;
		}
	}
}
$g_default_values['mail_timeout_minutes'] = (int)($g_default_values['mail_timeout']/60);


// ***********************
// * Eingabe verarbeiten *
// ***********************


//Wenn $_POST['action'] nicht definiert ist, wird Startseite angezeigt
//Andernfalls müssen Änderungen an der Datenbank durchgeführt werden
//oder Spezialseiten angezeigt werden.
if (isset($_POST['action']))
{
	if (in_array($_POST['action'],array('urlon','urloff','reallydelurl','seturl','cacheurl','editurl','delurl')) and isset($_POST['urlsel']) and is_array($_POST['urlsel']))
	{
		foreach($_POST['urlsel'] as $url_id)
		{
			// Prüfen, ob angegebene URL existiert
			//TODO: Datenbankabfragen sind effizienter, wenn prepare()
			//      außerhalb von foreach ausgeführt wird
			//      Lohnt sich der Aufwand?
			$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'webtest` WHERE id=? AND `group`=?');
			$dbs->execute(array($url_id, $g_active_group));
			if ($dbs->fetchColumn() != 1)
			{
				$t_warnings[] = 'URL '.$url_id.' nicht gefunden';
			}
			else
			{
				//Test für URL aktivieren
				if ($_POST['action']=='urlon')
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'webtest` SET active=1 WHERE id=?');
					$dbs->execute(array($url_id));
					$success_count += $dbs->rowCount();;
				}
				
				//Test für URL deaktivieren
				elseif ($_POST['action']=='urloff')
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'webtest` SET active=0 WHERE id=?');
					$dbs->execute(array($url_id));
					if ($dbs->rowCount())
						$success_count++;
				}
				
				//Cacheeintrag aktualisieren
				elseif ($_POST['action']=='cacheurl')
				{
					// Cacheeintrag löschen, damit er neu erzeugt wird
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'webtest` SET cache_time=0 WHERE id=?');
					$dbs->execute(array($url_id));
					$success_count++;
				}
				
				//Seite 'URL bearbeiten' anzeigen
				elseif ($_POST['action']=='editurl')
				{
					$t_show = 'editweb';
					$web_ids[] = $url_id;
				}
				
				// Seite 'URL löschen' anzeigen
				elseif ( $_POST['action'] == 'delurl')
				{
					$t_show = 'delweb';
					$web_ids[] = $url_id;
				}
				
				//Cacheeintrag als Erwartungswert setzen
				elseif ($_POST['action']=='seturl')
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'webtest` SET content=cache_content WHERE id=?');
					$dbs->execute(array($url_id));
					$success_count++;
				}
				
				//URL löschen
				elseif ($_POST['action']=='reallydelurl')
				{
					// Wenn $_POST['confirmdelete'] nicht gesetzt ist, dann wurde das Löschen
					// abgebrochen. In diesem Fall einfach Startseite zeigen
					if (isset($_POST['confirmdelete']))
					{
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'webtest` WHERE id=?');
						$dbs->execute(array($url_id));
						if (isset($_POST['dellogs']))
						{
							$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'logs` WHERE type=\'web\' AND tid=?');
							$dbs->execute(array($url_id));
						}
						$success_count++;
					}
				}
			}
		}
		
		if ($success_count)
		{
			if ($_POST['action']=='urlon')
				$t_infos[] = $success_count.' Webtests aktiviert'; 
			elseif ($_POST['action']=='urloff')
				$t_infos[] = $success_count.' Webtests deaktiviert';
			elseif ($_POST['action']=='cacheurl')
				$t_infos[] = 'Cache für '.$success_count.' Webtests aktualisiert';
			elseif ($_POST['action']=='seturl')
				$t_infos[] = 'Cachwert für '.$success_count.' Webtests als Erwartungswert übernommen.';
			elseif ($_POST['action']=='reallydelurl')
				$t_infos[] = $success_count.' Webtests gelöscht.';
		}
	}
	// Neue oder bearbeitete URLs speichern
	elseif ( $_POST['action'] == 'editurlsave' or $_POST['action'] == 'newurlsave')
	{
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Startseite zeigen
		if (isset($_POST['confirmsave']))
		{
			foreach($_POST['url'] as $url_id=>$null)
			{
				// für newurlsave ist $url_id nicht die Id in der Datenbank, sondern
				// wird nur für die Formularübertragung genutzt
				if (!isset($_POST['urlcomment'][$url_id]) or !isset($_POST['urltimeout_d'][$url_id]) or ($_POST['urltimeout_d'][$url_id] == '0' and !isset($_POST['urltimeout'][$url_id])) or !isset($_POST['urlretries_d'][$url_id]) or ($_POST['urlretries_d'][$url_id] == '0' and !isset($_POST['urlretries'][$url_id])) or !isset($_POST['urlredirects_d'][$url_id]) or ($_POST['urlredirects_d'][$url_id] == '0' and !isset($_POST['urlredirects'][$url_id])) or !isset($_POST['urlcheckstatuscode_d'][$url_id]) or !isset($_POST['urlcheckcontent_d'][$url_id]) or !isset($_POST['urlcertcheck_d'][$url_id]))
				{
					// Das kann nur passieren, wenn der Nutzer die
					// POST-Daten manipuliert hat.
					// Es wird keine Fehlermeldung gezeigt, die
					// Datenbank wird nicht verändert.
					continue;
				}
				elseif ( $_POST['action'] == 'newurlsave' and empty($_POST['url'][$url_id]) and empty($_POST['urlcomment'][$url_id]))
				{
					//Keine Werte eingegeben -> ignorieren
					continue;
				}
				elseif ( $_POST['action'] == 'editurlsave' )
				{
					// Prüfen, ob angegebene URL existiert
					$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'webtest` WHERE id=? AND `group`=?');
					$dbs->execute(array($url_id, $g_active_group));
					if ($dbs->fetchColumn() != 1)
					{
						// URL nicht gefunden. Nutzer kann den Fehler nicht beheben,
						// also muss das Bearbeiten-Formular nicht erneut
						// angezeigt werden.
						$t_warnings[] = 'URL '.$url_id.' nicht gefunden';
						continue;
					}
				}

				$error = FALSE;
				// Prüfen, ob URL erlaubt ist
				if (($val_url = validate_url($_POST['url'][$url_id])) !== TRUE)
				{
					$error = TRUE;
					$t_warnings[] = $val_url;
				}
				if ($_POST['urltimeout_d'][$url_id] == '0' and (!ctype_digit($_POST['urltimeout'][$url_id]) or $_POST['urltimeout'][$url_id] == '0'))
				{
					$t_warnings[] = 'Zeitlimit ist keine Zahl';
					$error = TRUE;
				}
				if ($_POST['urlretries_d'][$url_id] == '0' and !ctype_digit($_POST['urlretries'][$url_id]))
				{
					$t_warnings[] = 'Wiederholungen ist keine Zahl';
					$error = TRUE;
				}
				if ($_POST['urlredirects_d'][$url_id] == '0' and !ctype_digit($_POST['urlredirects'][$url_id]))
				{
					$t_warnings[] = 'Weiterleitungen ist keine Zahl';
					$error = TRUE;
				}
				
				if (!$error)
				{
					//Alles OK
					if ( $_POST['action'] == 'newurlsave')
					{
						$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'webtest` (url, active, content, comment, timeout, retries, redirects, check_statuscode, check_content, cert_check, `group`) VALUES (?, 0, \'\', ?, ?, ?, ?, ?, ?, ?, ?)');
						$dbs->execute(array(
							$_POST['url'][$url_id],
							$_POST['urlcomment'][$url_id],
							$_POST['urltimeout_d'][$url_id] == '0' ? $_POST['urltimeout'][$url_id] : '-1',
							$_POST['urlretries_d'][$url_id] == '0' ? $_POST['urlretries'][$url_id] : '-1',
							$_POST['urlredirects_d'][$url_id] == '0' ? $_POST['urlredirects'][$url_id] : '-1',
							$_POST['urlcheckstatuscode_d'][$url_id] == '0' ? (int)isset($_POST['urlcheckstatuscode'][$url_id]) : '-1',
							$_POST['urlcheckcontent_d'][$url_id] == '0' ? (int)isset($_POST['urlcheckcontent'][$url_id]) : '-1',
							$_POST['urlcertcheck_d'][$url_id] == '0' ? (int)isset($_POST['urlcertcheck'][$url_id]) : '-1',
							$g_active_group,
						));
					}
					else
					{
						//Cache leeren, wenn Test geändert wird
						$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'webtest` SET url=?, comment=?, cache_content=\'\', cache_time=0, timeout=?, retries=?, redirects=?, check_statuscode=?, check_content=?, cert_check=? WHERE id=?');
						$dbs->execute(array(
							$_POST['url'][$url_id],
							$_POST['urlcomment'][$url_id],
							$_POST['urltimeout_d'][$url_id] == '0' ? $_POST['urltimeout'][$url_id] : '-1',
							$_POST['urlretries_d'][$url_id] == '0' ? $_POST['urlretries'][$url_id] : '-1',
							$_POST['urlredirects_d'][$url_id] == '0' ? $_POST['urlredirects'][$url_id] : '-1',
							$_POST['urlcheckstatuscode_d'][$url_id] == '0' ? (int)isset($_POST['urlcheckstatuscode'][$url_id]) : '-1',
							$_POST['urlcheckcontent_d'][$url_id] == '0' ? (int)isset($_POST['urlcheckcontent'][$url_id]) : '-1',
							$_POST['urlcertcheck_d'][$url_id] == '0' ? (int)isset($_POST['urlcertcheck'][$url_id]) : '-1',
							$url_id,
						));
					}
					$success_count++;
				}
				else
				{
					$web_ids[] = $url_id;
					if (!isset($_POST['urltimeout'][$url_id])) $_POST['urltimeout'][$url_id] = '';
					if (!isset($_POST['urlretries'][$url_id])) $_POST['urlretries'][$url_id] = '';
					if (!isset($_POST['urlredirects'][$url_id])) $_POST['urlredirects'][$url_id] = '';
					if ($_POST['action'] == 'newurlsave')
					{
						$t_show = 'newweb';
					}
					else
					{
						$t_show = 'editweb';
					}
				}
			}
			if ($success_count)
			{
				if ( $_POST['action'] == 'newurlsave')
				{
					$t_infos[] = $success_count.' Webtests erfolgreich gespeichert';
				}
				else
				{
					$t_infos[] = $success_count.' Webtests erfolgreich bearbeitet';
				}
			}
		}
	}
	elseif (in_array($_POST['action'],array('mailon','mailoff','reallydelmail','resetmail','editmail','delmail','sendmail','getmail')) and isset($_POST['mailsel']) and is_array($_POST['mailsel']))
	{
		foreach($_POST['mailsel'] as $mail_id)
		{
			// Prüfen, ob angegebene mail existiert
			$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'mailtest` WHERE id=? AND `group`=?');
			$dbs->execute(array($mail_id, $g_active_group));
			if ($dbs->fetchColumn() != 1)
			{
				$t_warnings[] = 'Email-Test '.$mail_id.' nicht gefunden';
			}
			else
			{
				//Test für mail aktivieren
				if ($_POST['action']=='mailon')
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'mailtest` SET active=1 WHERE id=?');
					$dbs->execute(array($mail_id));
					$success_count += $dbs->rowCount();
				}
				
				//Test für mail deaktivieren
				elseif ($_POST['action']=='mailoff')
				{
					$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'mailtest` SET active=0 WHERE id=?');
					$dbs->execute(array($mail_id));
					$success_count += $dbs->rowCount();
				}
				
				//Nicht länger auf bereits gesendete Mails warten
				elseif ($_POST['action']=='resetmail')
				{
					$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sent` WHERE tid=?');
					$dbs->execute(array($mail_id));
					$success_count++;
				}
				
				//Mails senden
				elseif ($_POST['action']=='sendmail')
				{
					require_once('smtpLib.php');
					$dbs = $g_db->prepare('SELECT send_via, `group`, comment FROM `'.DB_PRE.'mailtest` WHERE id=?');
					$dbs->execute(array($mail_id));
					$mailtest = $dbs->fetch();
					$send_via = standard($mailtest['send_via'], $g_default_values['mail_send_via']);
					$dbs = $g_db->prepare('SELECT id, address FROM `'.DB_PRE.'mail_sendto` WHERE tid=?');
					$dbs->execute(array($mail_id));
					$sendto_list = array();
					while ($row = $dbs->fetch())
					{
						$sendto_list[$row['id']] = $row['address'];
					}
					if ($send_via == 0)
					{
						$smtp=false;
					}
					else
					{
						//SMTP-Server benutzen
						$dbs = $g_db->prepare('SELECT addr, port, encryption, authentication, username, password, certcheck, sender FROM `'.DB_PRE.'smtp` WHERE id=?');
						$dbs->execute(array($send_via));
						$smtp = $dbs->fetch();
					}
					
					$send_error = false;
					$mailer = new mail_send_wrapper;
					if (!$mailer->connect($smtp))
					{
						$t_warnings[] = 'Verbindung zum SMTP-Server fehlgeschlagen: '.$mailer->geterror();
						$send_error = true;
					}
					// Mails auch versuchen zu versenden, wenn connect()
					// fehlschlägt, damit eine Warnung verschickt wird

					$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'mail_sent` (aid, tid, time, hash) VALUES (?,?,?,?)');
					foreach($sendto_list as $sendto_id=>$sendto_addr)
					{
						while (true)
						{
							try
							{
								$mail_hash=rand_str(15);
								$dbs->execute(array($sendto_id, $mail_id, time(),$mail_hash));
								// Wenn hash schon vergeben, dann wird Exception geworfen
								// break wird nicht ausgeführt -> weiterer Schleifendurchlauf
								break;
							}
							catch (PDOException $e)
							{
								// Wenn Code == 1062 (Duplicate Entry), dann wird 
								// die normale Fehlerbehandlung nicht durchgeführt
								if ($e->errorInfo[1]!=1062) throw $e;
							}
						}
						if ($mailer->send($sendto_addr, 'Mailtest', $mail_hash))
						{
							$success_count++;
						}
						else
						{
							$t_warnings[] = 'Mail konnte nicht gesendet werden. ('.$sendto_addr.')';
							$send_error = true;
						}
						$mailer->disconnect();
					}
					if ($log = $mailer->getlog())
						logfile($mail_id, 'mail', 0, $send_error, $mailtest['group'], 'S: '.implode(', ',$sendto_list).($mailtest['comment'] ? ' ('.$mailtest['comment'].')' : ''), $log);
				}
				
				//Mails abrufen
				elseif ($_POST['action']=='getmail')
				{
					$dbs = $g_db->prepare('SELECT m.path, m.username, m.password, m.`group`, m.comment, GROUP_CONCAT(s.address SEPARATOR \', \') AS sendto FROM `'.DB_PRE.'mailtest` AS m LEFT JOIN `'.DB_PRE.'mail_sendto` AS s ON m.id=s.tid WHERE m.id=? GROUP BY m.id');
					$dbs->execute(array($mail_id));
					$login_data = $dbs->fetch();
					
					$dbs = $g_db->prepare('SELECT hash FROM `'.DB_PRE.'mail_sent` WHERE tid=?');
					$dbs->execute(array($mail_id));
					$hashes = $dbs->fetchAll(PDO::FETCH_COLUMN);
					
					require_once('imapLib.php');
					$imap = new imap_mail;
					$received = $imap->check($login_data['path'], $login_data['username'], $login_data['password'], $hashes);
					if ($received === FALSE)
					{
						$t_warnings[] = 'Mails konnten nicht abgerufen werden'.($imap->geterror() ? ': '.$imap->geterror() : '').' ('.$login_data['path'].' / '.$login_data['username'].')';
					}
					else
					{
						$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'mailtest` SET lastcheck=? WHERE id=?');
						$dbs->execute(array(time(),$mail_id));
						if (!empty($received))
						{
							$dbs = $g_db->query('DELETE FROM `'.DB_PRE.'mail_sent` WHERE hash IN '.in_statement($received, $g_db));
						}
						$success_count++;
					}
					logfile($mail_id, 'mail', 1, ($received === FALSE), $login_data['group'], 'R: '.$login_data['sendto'].($login_data['comment'] ? ' ('.$login_data['comment'].')' : ''), $imap->getlog());
				}
				
				//Seite 'mail bearbeiten' anzeigen
				elseif ($_POST['action']=='editmail')
				{
					$t_show = 'editmail';
					$mail_ids[] = $mail_id;
				}
				
				// Seite 'mail löschen' anzeigen
				elseif ( $_POST['action'] == 'delmail')
				{
					$t_show = 'delmail';
					$mail_ids[] = $mail_id;
				}
				
				//Email löschen
				elseif ($_POST['action']=='reallydelmail')
				{
					// Wenn $_POST['confirmdelete'] nicht gesetzt ist, dann wurde das Löschen
					// abgebrochen. In diesem Fall einfach Startseite zeigen
					if (isset($_POST['confirmdelete']))
					{
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sent` WHERE tid=?');
						$dbs->execute(array($mail_id));
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sendto` WHERE tid=?');
						$dbs->execute(array($mail_id));
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mailtest` WHERE id=?');
						$dbs->execute(array($mail_id));
						if (isset($_POST['dellogs']))
						{
							$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'logs` WHERE type=\'mail\' AND tid=?');
							$dbs->execute(array($mail_id));
						}
						$success_count++;
					}
				}
			}
		}
		
		if ($success_count)
		{
			if ($_POST['action']=='mailon')
				$t_infos[] = $success_count.' Mailtests aktiviert';
			elseif ($_POST['action']=='mailoff')
				$t_infos[] = $success_count.' Mailtests deaktiviert';
			elseif ($_POST['action']=='resetmail')
				$t_infos[] = $success_count.' Mailtests zurückgesetzt';
			elseif ($_POST['action']=='sendmail')
				$t_infos[] = $success_count.' Emails gesendet';
			elseif ($_POST['action']=='getmail')
				$t_infos[] = $success_count.' Emailkonten abgerufen';
			elseif ($_POST['action']=='reallydelmail')
				$t_infos[] = $success_count.' Mailtests gelöscht';
		}
	}
	// Neue oder bearbeitete mails speichern
	elseif ($_POST['action'] == 'newmailsave' or $_POST['action'] == 'editmailsave')
	{
		// Wenn $_POST['confirmsave'] nicht gesetzt ist, dann wurde das Bearbeiten
		// abgebrochen. In diesem Fall einfach Startseite zeigen
		if (isset($_POST['confirmsave']))
		{
			foreach($_POST['mailaddr'] as $mail_id=>$null)
			{
				// für newmailsave ist $mail_id nicht die Id in der Datenbank, sondern
				// wird nur für die Formularübertragung genutzt
				if (!isset($_POST['mailpath'][$mail_id]) or !isset($_POST['mailuser'][$mail_id]) or !isset($_POST['mailpw'][$mail_id]) or !isset($_POST['mailcomment'][$mail_id]) or !isset($_POST['mail_timeout_d'][$mail_id]) or ($_POST['mail_timeout_d'][$mail_id] == '0' and !isset($_POST['mail_timeout'][$mail_id])) or !isset($_POST['mail_send_via_d'][$mail_id]) or ($_POST['mail_send_via_d'][$mail_id] == '0' and !isset($_POST['mail_send_via'][$mail_id])) )
				{
					// Das kann nur passieren, wenn der Nutzer die
					// POST-Daten manipuliert hat.
					// Es wird keine Fehlermeldung gezeigt, die
					// Datenbank wird nicht verändert.
					continue;
				}
				elseif ( $_POST['action'] == 'newmailsave' and empty($_POST['mailaddr'][$mail_id]) and empty($_POST['mailpath'][$mail_id]) and empty($_POST['mailuser'][$mail_id]) and empty($_POST['mailpw'][$mail_id]) and empty($_POST['mailcomment'][$mail_id]))
				{
					// Keine Werte eingegeben -> ignorieren
					continue;
				}
				elseif ( $_POST['action'] == 'editmailsave' )
				{
				// Prüfen, ob angegebene mail existiert
				$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'mailtest` WHERE id=? AND `group`=?');
				$dbs->execute(array($mail_id, $g_active_group));
				if ($dbs->fetchColumn() != 1)
					{
						// Mailtest nicht gefunden. Nutzer kann den Fehler nicht beheben,
						// also muss das Bearbeiten-Formular nicht erneut
						// angezeigt werden.
						$t_warnings[] = 'Email-Test '.$mail_id.' nicht gefunden';
						continue;
					}
				}

				$error = FALSE;
				// Prüfen, ob Emailadresse erlaubt ist
				if (!preg_match(perl_regex(MAIL_PATTERN),$_POST['mailaddr'][$mail_id]))
				{
					$t_warnings[] = 'Geben Sie die Emailadressen als kommagetrennte Liste an.';
					$error = TRUE;
				}
				if (!preg_match(perl_regex(IMAP_PATTERN),$_POST['mailpath'][$mail_id]))
				{
					$t_warnings[] = 'Geben Sie einen gültigen imap_open-Mailboxpfad an.';
					$error = TRUE;
				}
				if ($_POST['mail_timeout_d'][$mail_id] == '0' and (!ctype_digit($_POST['mail_timeout'][$mail_id]) or $_POST['mail_timeout'][$mail_id] == '0'))
				{
					$t_warnings[] = 'Zeitlimit ist keine Zahl';
					$error = TRUE;
				}
				
				// Keinen SMTP-Server verwenden, der nicht existiert
				if ($_POST['mail_send_via_d'][$mail_id] == '0' and $_POST['mail_send_via'][$mail_id] != '0')
				{
					//Versand per SMTP
					$dbs = $g_db->prepare('SELECT COUNT(*) FROM `'.DB_PRE.'smtp` WHERE id=? and `group`=?');
					$dbs->execute(array($_POST['mail_send_via'][$mail_id], $g_active_group));
					if ($dbs->fetchColumn() == 0)
					{
						$t_warnings[] = 'Dieser SMTP-Server existiert nicht';
						$error = TRUE;
					}
				}
				
				if (!$error)
				{
					//Emailangaben zulässig.
					if ( $_POST['action'] == 'newmailsave')
					{
						$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'mailtest` (path, username, password, active, comment, timeout, send_via, lastcheck, `group`) VALUES (?, ?, ?, 0, ?, ?, ?, ?, ?)');
						$dbs->execute(array(
							$_POST['mailpath'][$mail_id],
							$_POST['mailuser'][$mail_id],
							$_POST['mailpw'][$mail_id],
							$_POST['mailcomment'][$mail_id],
							$_POST['mail_timeout_d'][$mail_id] == '0' ? $_POST['mail_timeout'][$mail_id]*60 : '-1',
							$_POST['mail_send_via_d'][$mail_id] == '0' ? $_POST['mail_send_via'][$mail_id] : '-1',
							time(),
							$g_active_group,
						));
						$db_mail_id = $g_db->lastInsertId();
						$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'mail_sendto` (tid, address) VALUES (?, ?)');
						foreach (explode(',',$_POST['mailaddr'][$mail_id]) as $addr)
						{
							$dbs->execute(array($db_mail_id, trim($addr)));
						}
					}
					else // $_POST['action'] == 'editmailsave'
					{
						if (empty($_POST['mailpw'][$mail_id]))
						{
							//Passwort nicht ändern, wenn Feld leer gelassen wird.
							$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'mailtest` SET path=?, username=?, comment=?, timeout=?, send_via=?, lastcheck=? WHERE id=?');
							$dbs->execute(array(
								$_POST['mailpath'][$mail_id],
								$_POST['mailuser'][$mail_id],
								$_POST['mailcomment'][$mail_id],
								$_POST['mail_timeout_d'][$mail_id] == '0' ? $_POST['mail_timeout'][$mail_id]*60 : '-1',
								$_POST['mail_send_via_d'][$mail_id] == '0' ? $_POST['mail_send_via'][$mail_id] : '-1',
								time(),
								$mail_id,
							));
						}
						else
						{
							$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'mailtest` SET path=?, username=?, password=?, comment=?, timeout=?, send_via=?, lastcheck=? WHERE id=?');
							$dbs->execute(array(
								$_POST['mailpath'][$mail_id],
								$_POST['mailuser'][$mail_id],
								$_POST['mailpw'][$mail_id],
								$_POST['mailcomment'][$mail_id],
								$_POST['mail_timeout_d'][$mail_id] == '0' ? $_POST['mail_timeout'][$mail_id] : '-1',
								$_POST['mail_send_via_d'][$mail_id] == '0' ? $_POST['mail_send_via'][$mail_id] : '-1',
								time(),
								$mail_id,
							));
						}
						
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sent` WHERE tid=?');
						$dbs->execute(array($mail_id));
						$dbs = $g_db->prepare('DELETE FROM `'.DB_PRE.'mail_sendto` WHERE tid=?');
						$dbs->execute(array($mail_id));
						
						$dbs = $g_db->prepare('INSERT INTO `'.DB_PRE.'mail_sendto` (tid, address) VALUES (?, ?)');
						foreach (explode(',',$_POST['mailaddr'][$mail_id]) as $addr)
						{
							$dbs->execute(array($mail_id, trim($addr)));
						}
					}
						$success_count++;
				}
				else
				{
					$mail_ids[] = $mail_id;
					if (!isset($_POST['mail_timeout'][$mail_id])) $_POST['mail_timeout'][$mail_id] = '';
					if (!isset($_POST['mail_send_via'][$mail_id])) $_POST['mail_send_via'][$mail_id] = '0';
					if ($_POST['action'] == 'newmailsave')
					{
						$t_show = 'newmail';
					}
					else
					{
						$t_show = 'editmail';
					}
				}
			}
			if ($success_count)
			{
				if ( $_POST['action'] == 'newurlsave')
				{
				$t_infos[] = $success_count.' Mailtests erfolgreich gespeichert';
				}
				else
				{
				$t_infos[] = $success_count.' Mailtests erfolgreich geändert';
				}
			}
		}
	}
}
elseif (isset($_GET['action']))
{
	// Formular für neue URLs
	if ( $_GET['action'] == 'newurl')
	{
		$t_show = 'newweb';
	}
	// Formular für neue Mailtests
	elseif ($_GET['action'] == 'newmail')
	{
		$t_show = 'newmail';
	}
}


// ***********************
// * Ausgabe vorbereiten *
// ***********************



// Liste mit Ergebnissen des Webseitentests erzeugen
// Cacheeintrag erzeugen, wenn er noch nicht existiert

$t_web_list = array();

if ($t_show == 'newweb')
{
	if (!empty($web_ids))
	{
		// Eingegebene Werte sind fehlerhaft, müssen nochmals
		// angezeigt werden.
		// Eingabefelder werden neu nummeriert.
		$new_id = 0;
		foreach ($web_ids as $old_id)
		{
			$t_web_list[] = array(
				'id' => $new_id,
				'url' => htmlspecialchars($_POST['url'][$old_id]),
				'div_class' => 'disabled',
				'site_ok' => TRUE,
				'expected' => '',
				'found' => '',
				'comment' => htmlspecialchars($_POST['urlcomment'][$old_id]),
				'timeout' => htmlspecialchars($_POST['urltimeout'][$old_id]),
				'timeout_d' => ($_POST['urltimeout_d'][$old_id] == '1'),
				'retries' => htmlspecialchars($_POST['urlretries'][$old_id]),
				'retries_d' => ($_POST['urlretries_d'][$old_id] == '1'),
				'redirects' => htmlspecialchars($_POST['urlredirects'][$old_id]),
				'redirects_d' => ($_POST['urlredirects_d'][$old_id] == '1'),
				'checkstatuscode' => isset($_POST['urlcheckstatuscode'][$old_id]),
				'checkstatuscode_d' => ($_POST['urlcheckstatuscode_d'][$old_id] == '1'),
				'checkcontent' => isset($_POST['urlcheckcontent'][$old_id]),
				'checkcontent_d' => ($_POST['urlcheckcontent_d'][$old_id] == '1'),
				'certcheck' => isset($_POST['urlcertcheck'][$old_id]),
				'certcheck_d' => ($_POST['urlcertcheck_d'][$old_id] == '1'),
				);
			$new_id++;
		}
	}
	else
	{
		// Keine Fehlerkorrektur, sondern leeres Formular
		$t_web_list[] = array(
			'id' => 0,
			'url' => '',
			'div_class' => 'disabled',
			'site_ok' => TRUE,
			'expected' => '',
			'found' => '',
			'comment' => '',
			'timeout' => '',
			'timeout_d' => true,
			'retries' => '',
			'retries_d' => true,
			'redirects' => '',
			'redirects_d' => true,
			'checkstatuscode' => FALSE,
			'checkstatuscode_d' => true,
			'checkcontent' => FALSE,
			'checkcontent_d' => true,
			'certcheck' => FALSE,
			'certcheck_d' => true,
			);
	}
}
elseif ($t_show == 'normal' or $t_show == 'editweb' or $t_show == 'delweb')
{
	// aktive Webtests ohne Cache-Wert finden
	$dbs = $g_db->prepare('SELECT id, url, timeout, redirects, check_statuscode, check_content, cert_check FROM `'.DB_PRE.'webtest` WHERE cache_time=0 AND `group`=?');
	$dbs->execute(array($g_active_group));
	$needs_caching = $dbs->fetchAll();
	if (count($needs_caching))
	{
		//Weblib laden
		require_once($g_settings['weblib']);
		$weblib = WEBLIB;
		$weblib = new $weblib;
		foreach ($needs_caching as $row)
		{
			$cache_value = $weblib->add(
				$row['id'],
				$row['url'],
				standard($row['timeout'], $g_default_values['web_timeout']),
				standard($row['redirects'], $g_default_values['web_redirects']),
				0, '',
				standard($row['check_statuscode'], $g_default_values['web_check_statuscode']),
				standard($row['check_content'], $g_default_values['web_check_content']),
				standard($row['cert_check'], $g_default_values['web_cert_check'])
				);
		}
		$dbs = $g_db->prepare('UPDATE `'.DB_PRE.'webtest` SET cache_content=?, cache_time=? WHERE id=?');
		$dbs2 = $g_db->prepare('SELECT url, comment, `group`, content FROM `'.DB_PRE.'webtest` WHERE id=?');
		foreach ($weblib->exec() as $tested)
		{
			$dbs->execute(array(end($tested['result']),time(),$tested['id']));
			$dbs2->execute(array($tested['id']));
			$row = $dbs2->fetch();
			
			$log = 'Erwartet: '.$row['content']."\n";
			foreach ($tested['result'] as $n=>$result)
			{
				if ($n==0)
					$log .= 'Gefunden: '.$result."\n";
				else
					$log .= '          '.$result."\n";
			}
			$log .= "\n".$tested['log'];

			logfile($tested['id'], 'web', 0, ($row['content']!=end($tested['result']) and $row['content']!=''), $row['group'], $row['url'].($row['comment'] ? ' ('.$row['comment'].')' : ''), $log);
		}
		unset($weblib);
	}
	
	if (!empty($web_ids) and $_POST['action'] == 'editurlsave')
	{
		// Angaben waren fehlerhaft, erneut anzeigen
		// Notwendige POST-Variablen sind alle vorhanden, das wurde geprüft
		$dbs = $g_db->prepare('SELECT w.id, w.active, w.content, w.cache_content, w.cache_time, COUNT(l.id) AS logcount FROM `'.DB_PRE.'webtest` AS w LEFT JOIN `'.DB_PRE.'logs` AS l ON w.id=l.tid AND l.type = \'web\' WHERE w.`group`=? AND w.id IN '.in_statement($web_ids, $g_db).' GROUP BY w.id ORDER BY w.id');
		$dbs->execute(array($g_active_group));
	
		while ($row = $dbs->fetch())
		{
			$t_web_list[] = array(
				'id' => $row['id'],
				'url' => htmlspecialchars($_POST['url'][$row['id']]),
				'div_class' => ($row['active']) ? (($row['content'] == $row['cache_content']) ? 'ok' : 'error') : 'disabled',
				'site_ok' => ($row['content'] == $row['cache_content']),
				'expected' => htmlspecialchars($row['content']),
				'found' => htmlspecialchars($row['cache_content']).(($row['cache_time']) ? ' <i>(geprüft: '.htmlspecialchars(date($g_settings['dateformat'],$row['cache_time'])).')</i>' : ''),
				'comment' => htmlspecialchars($_POST['urlcomment'][$row['id']]),
				'timeout' => htmlspecialchars($_POST['urltimeout'][$row['id']]),
				'timeout_d' => ($_POST['urltimeout_d'][$row['id']] == '1'),
				'retries' => htmlspecialchars($_POST['urlretries'][$row['id']]),
				'retries_d' => ($_POST['urlretries_d'][$row['id']] == '1'),
				'redirects' => htmlspecialchars($_POST['urlredirects'][$row['id']]),
				'redirects_d' => ($_POST['urlredirects_d'][$row['id']] == '1'),
				'checkstatuscode' => isset($_POST['urlcheckstatuscode'][$row['id']]),
				'checkstatuscode_d' => ($_POST['urlcheckstatuscode_d'][$row['id']] == '1'),
				'checkcontent' => isset($_POST['urlcheckcontent'][$row['id']]),
				'checkcontent_d' => ($_POST['urlcheckcontent_d'][$row['id']] == '1'),
				'certcheck' => isset($_POST['urlcertcheck'][$row['id']]),
				'certcheck_d' => ($_POST['urlcertcheck_d'][$row['id']] == '1'),
				'logcount' => htmlspecialchars($row['logcount']),
				);
		}
	}
	else
	{
		if (!empty($web_ids))
		{
			$dbs = $g_db->prepare('SELECT w.id, w.url, w.active, w.content, w.cache_content, w.cache_time, w.comment, w.timeout, w.retries, w.redirects, w.check_statuscode, w.check_content, w.cert_check, COUNT(l.id) AS logcount FROM `'.DB_PRE.'webtest` AS w LEFT JOIN `'.DB_PRE.'logs` AS l ON w.id=l.tid AND l.type = \'web\' WHERE w.`group`=? AND w.id IN '.in_statement($web_ids, $g_db).' GROUP BY w.id ORDER BY w.id');
		}
		else
		{
			$dbs = $g_db->prepare('SELECT w.id, w.url, w.active, w.content, w.cache_content, w.cache_time, w.comment, w.timeout, w.retries, w.redirects, w.check_statuscode, w.check_content, w.cert_check, COUNT(l.id) AS logcount FROM `'.DB_PRE.'webtest` AS w LEFT JOIN `'.DB_PRE.'logs` AS l ON w.id=l.tid AND l.type = \'web\' WHERE w.`group`=? GROUP BY w.id ORDER BY w.id');
		}
		$dbs->execute(array($g_active_group));
		
		while ($row = $dbs->fetch())
		{
			$t_web_list[] = array(
				'id' => $row['id'],
				'url' => htmlspecialchars($row['url']),
				'div_class' => ($row['active']) ? (($row['content'] == $row['cache_content']) ? 'ok' : 'error') : 'disabled',
				'site_ok' => ($row['content'] == $row['cache_content']),
				'expected' => htmlspecialchars($row['content']),
				'found' => htmlspecialchars($row['cache_content']).(($row['cache_time']) ? ' <i>(geprüft: '.htmlspecialchars(date($g_settings['dateformat'],$row['cache_time'])).')</i>' : ''),
				'comment' => htmlspecialchars($row['comment']),
				'timeout' => ($row['timeout'] == -1) ? '' : htmlspecialchars($row['timeout']),
				'timeout_d' => ($row['timeout'] == -1),
				'retries' => ($row['retries'] == -1) ? '' : htmlspecialchars($row['retries']),
				'retries_d' => ($row['retries'] == -1),
				'redirects' => ($row['redirects'] == -1) ? '' : htmlspecialchars($row['redirects']),
				'redirects_d' => ($row['redirects'] == -1),
				'checkstatuscode' => ($row['check_statuscode'] == 1),
				'checkstatuscode_d' => ($row['check_statuscode'] == -1),
				'checkcontent' => ($row['check_content'] == 1),
				'checkcontent_d' => ($row['check_content'] == -1),
				'certcheck' => ($row['cert_check'] == 1),
				'certcheck_d' => ($row['cert_check'] == -1),
				'logcount' => htmlspecialchars($row['logcount']),
				);
		}
	}
}


// Liste mit Ergebnissen des Mailtests erzeugen
$t_mail_list = array();
if ($t_show == 'newmail')
{
	if (!empty($mail_ids))
	{
		// Eingegebene Werte sind fehlerhaft, müssen nochmals
		// angezeigt werden.
		// Eingabefelder werden neu nummeriert.
		$new_id = 0;
		foreach ($mail_ids as $old_id)
		{
			$t_mail_list[] = array(
				'id' => $new_id,
				'path' => htmlspecialchars($_POST['mailpath'][$old_id]),
				'div_class' => 'disabled',
				'user' => htmlspecialchars($_POST['mailuser'][$old_id]),
				'password' => htmlspecialchars($_POST['mailpw'][$old_id]),
				'addresses' => htmlspecialchars($_POST['mailaddr'][$old_id]),
				'comment' => htmlspecialchars($_POST['mailcomment'][$old_id]),
				'timeout' => htmlspecialchars($_POST['mail_timeout'][$old_id]),
				'timeout_d' => ($_POST['mail_timeout_d'][$old_id] == '1'),
				'send_via' => $_POST['mail_send_via'][$old_id],
				'send_via_d' => ($_POST['mail_send_via_d'][$old_id] == '1'),
				);
			$new_id++;
		}
	}
	else
	{
		// Keine Fehlerkorrektur, sondern leeres Formular
		$t_mail_list[] = array(
			'id' => 0,
			'path' => '',
			'div_class' => 'disabled',
			'user' => '',
			'password' => '',
			'addresses' => '',
			'comment' => '',
			'timeout' => '',
			'timeout_d' => true,
			'send_via' => '',
			'send_via_d' => true,
			);
	}
}
elseif ($t_show == 'normal' or $t_show == 'editmail' or $t_show == 'delmail')
{
	if (!empty($mail_ids) and $_POST['action'] == 'editmailsave')
	{
		// Angaben waren fehlerhaft, erneut anzeigen
		// Notwendige POST-Variablen sind alle vorhanden, das wurde geprüft
		$dbs = $g_db->prepare('SELECT mailtest.id, mailtest.active, mailtest.lastcheck,  mailtest.timeout, MIN(mail_sent.time) AS time, COUNT(DISTINCT mail_sent.hash) AS count, COUNT(DISTINCT logs.id) AS logcount FROM `'.DB_PRE.'mailtest` AS mailtest LEFT JOIN `'.DB_PRE.'mail_sent` AS mail_sent ON mailtest.id = mail_sent.tid LEFT JOIN `'.DB_PRE.'logs` AS logs ON mailtest.id = logs.tid AND logs.type = \'mail\' WHERE mailtest.`group`=? AND mailtest.id IN '.in_statement($mail_ids, $g_db).' GROUP BY mailtest.id ORDER BY mailtest.id');
		$dbs->execute(array($g_active_group));
		
		while ($row = $dbs->fetch())
		{
			$missing_time = ($row['count']) ? max($row['lastcheck']-$row['time'],0) : 0;
			$timeout = standard($row['timeout'], $g_default_values['mail_timeout']);
			$t_mail_list[] = array(
				'id' => $row['id'],
				'path' => htmlspecialchars($_POST['mailpath'][$row['id']]),
				'div_class' => ($row['active']) ? (($missing_time > $timeout) ? 'error' : 'ok') : 'disabled',
				'user' => htmlspecialchars($_POST['mailuser'][$row['id']]),
				'password' => htmlspecialchars($_POST['mailpw'][$row['id']]),
				'addresses' => htmlspecialchars($_POST['mailaddr'][$row['id']]),
				'status' => $row['count'].' ausstehende Emails <i>('.(($row['count']) ? round($missing_time/60).' Minuten, ' : '').'geprüft: '.htmlspecialchars(date($g_settings['dateformat'],$row['lastcheck'])).')</i>',
				'comment' => htmlspecialchars($_POST['mailcomment'][$row['id']]),
				'timeout' => htmlspecialchars($_POST['mail_timeout'][$row['id']]),
				'timeout_d' => ($_POST['mail_timeout_d'][$row['id']] == '1'),
				'send_via' => $_POST['mail_send_via'][$row['id']],
				'send_via_d' => ($_POST['mail_send_via_d'][$row['id']] == '1'),
				'logcount' => htmlspecialchars($row['logcount']),
				);
		}
	}
	else
	{
		if (!empty($mail_ids))
		{
			$dbs = $g_db->prepare('SELECT mailtest.id, mailtest.path, mailtest.username, mailtest.password, mailtest.active, mailtest.lastcheck, mailtest.comment, mailtest.timeout, mailtest.send_via, MIN(mail_sent.time) AS time, GROUP_CONCAT(DISTINCT mail_sendto.address SEPARATOR \', \') as sendto, COUNT( DISTINCT mail_sent.hash) AS count, COUNT(DISTINCT logs.id) AS logcount FROM `'.DB_PRE.'mailtest` AS mailtest LEFT JOIN `'.DB_PRE.'mail_sendto` AS mail_sendto ON mailtest.id = mail_sendto.tid LEFT JOIN `'.DB_PRE.'mail_sent` AS mail_sent ON mail_sendto.id = mail_sent.aid LEFT JOIN `'.DB_PRE.'logs` AS logs ON mailtest.id = logs.tid AND logs.type = \'mail\' WHERE mailtest.`group`=? AND mailtest.id IN '.in_statement($mail_ids, $g_db).' GROUP BY mailtest.id ORDER BY mailtest.id');
		}
		else
		{
			$dbs = $g_db->prepare('SELECT mailtest.id, mailtest.path, mailtest.username, mailtest.password, mailtest.active, mailtest.lastcheck, mailtest.comment, mailtest.timeout, mailtest.send_via, MIN(mail_sent.time) AS time, GROUP_CONCAT(DISTINCT mail_sendto.address SEPARATOR \', \') as sendto, COUNT( DISTINCT mail_sent.hash) AS count, COUNT(DISTINCT logs.id) AS logcount FROM `'.DB_PRE.'mailtest` AS mailtest LEFT JOIN `'.DB_PRE.'mail_sendto` AS mail_sendto ON mailtest.id = mail_sendto.tid LEFT JOIN `'.DB_PRE.'mail_sent`AS mail_sent ON mail_sendto.id = mail_sent.aid LEFT JOIN `'.DB_PRE.'logs` AS logs ON mailtest.id = logs.tid AND logs.type = \'mail\' WHERE mailtest.`group`=? GROUP BY mailtest.id ORDER BY mailtest.id');
		}
		$dbs->execute(array($g_active_group));
		
		while ($row = $dbs->fetch())
		{
			$missing_time = ($row['count']) ? max($row['lastcheck']-$row['time'],0) : 0;
			$timeout = standard($row['timeout'], $g_default_values['mail_timeout']);
			$t_mail_list[] = array(
				'id' => $row['id'],
				'path' => htmlspecialchars($row['path']),
				'div_class' => ($row['active']) ? (($missing_time > $timeout) ? 'error' : 'ok') : 'disabled',
				'user' => htmlspecialchars($row['username']),
				'password' => '',
				'addresses' => htmlspecialchars($row['sendto']),
				'status' => $row['count'].' ausstehende Emails <i>('.(($row['count']) ? round($missing_time/60).' Minuten, ' : '').'geprüft: '.htmlspecialchars(date($g_settings['dateformat'],$row['lastcheck'])).')</i>',
				'comment' => htmlspecialchars($row['comment']),
				'timeout' => ($row['timeout'] == -1) ? '' : htmlspecialchars((int)($row['timeout']/60)),
				'timeout_d' => ($row['timeout'] == -1),
				'send_via' => ($row['send_via'] == -1) ? 0 : $row['send_via'],
				'send_via_d' => ($row['send_via'] == -1),
				'logcount' => htmlspecialchars($row['logcount']),
				);
		}
	}
}

if ($t_show == 'normal' or $t_show == 'editmail' or $t_show == 'delmail' or $t_show == 'newmail')
{
	$dbs = $g_db->prepare('SELECT id, CONCAT(\'SMTP: \',name) AS name FROM `'.DB_PRE.'smtp` WHERE `group`=? ORDER BY name');
	$dbs->execute(array($g_active_group));
	$t_smtp_list = array_merge(array(array('id'=>0,'name'=>'PHP-mail')),$dbs->fetchAll());
}

if ($t_show == 'editmail' or $t_show == 'delmail' or $t_show == 'newmail')
{
	//Name des Standard-Mailversands in $g_default_values['mail_send_via_name'] speichern
	
	// Standardwert ist eventuell nicht in $t_smtp_list enthalten
	// in diesem Fall 'Globaler SMTP' anzeigen.
	$g_default_values['mail_send_via_name'] = 'Globaler SMTP';
	foreach($t_smtp_list as $item)
	{
		if ($g_default_values['mail_send_via']==$item['id'])
		{
			$g_default_values['mail_send_via_name'] = $item['name'];
			break;
		}
	}
}

if ($t_show == 'normal' or $t_show == 'delmail')
{
	// Für jeden Mailtest den Names des verwendeten Mailversands anzeigen
	foreach ($t_mail_list as &$entry)
	{
		$sv = ($entry['send_via_d']) ? $g_default_values['mail_send_via'] : $entry['send_via'];
		// Standardwert ist eventuell nicht in $t_smtp_list enthalten
		// in diesem Fall 'Globaler SMTP' anzeigen.
		$entry['send_via_name'] = 'Globaler SMTP';
		foreach($t_smtp_list as $item)
		{
			if ($sv==$item['id'])
			{
				$entry['send_via_name'] = $item['name'];
				break;
			}
		}
	}
	unset($entry);
}
